/*
############################################################################
##                                                                        ##
##  AM5400 Device Description, File AM5400.ddl, 19 may 2000               ##
##                                                                        ##
##  Copyright 2000 ABB Automation Products GmbH, all rights reserved      ##
##                                                                        ##
##  This software may not be used, either directly or by reference,       ##
##  such that the software provides functionality to an end customer,     ##
##  unless explicitly lisenced by Bailey Fischer & Porter GmbH.           ##
##                                                                        ##
##  Author:                                                               ##
##    Frank Wiederhold                                                    ##
##    ABB Automation Products GmbH                                        ##
##    Postfach 1843                                                       ##
##    37070 Goettingen                                                    ##
##    Germany                                                             ##
##                                                                        ##
##    Fax: German Number: +49 551 905 720                                 ##
##         From USA     : 49-551-905-720                                  ##
##                                                                        ##
############################################################################
*/


MANUFACTURER        ABB,
DEVICE_TYPE         _AM5400,
DEVICE_REVISION     0,
DD_REVISION         0



/*--------------------------------------------------------------------------
19 may 2000, FW:
	copy sk5460_0.ddl -> am5400_0.ddl
	changes:	MANUFACTURER ABB, DEVICE_TYPE _AM5400, DEVICE_REVISION 0, DD_REVISION 0
  					REDEFINITIONS VARIABLE manufacturer_id  -> 	{ 26, "ABB Automation" }
    						 					VARIABLE device_type      ->  { 27, "AM5400"    }


----------------------------------------------------------------------------

--------------------------------------------------------------------------*/
     
/*
############################################################################
##                                                                        ##
##                            LABEL + HELP                                ##
##                                                                        ##
############################################################################
*/

#define  help_actual_flow_value                                             \
            "|001Actual Flow Qv. Flow under operating conditions"           \
            "|049Aktueller Durchfluss Qv. Durchfluss bei Betriebsbedingungen"

#define  help_standard_flow_value                                           \
            "|001Standard Flow Qn. Flow under standard conditions"          \
            "|049Standard Durchfluss Qn. Durchfluss bei Standardbetrieb"

#define  help_mass_flow_value                                               \
            "|001Mass Flow Qm. "                                            \
                "Operating flow multiplied with operating density."         \
            "|049Massedurchfluss Qm. "                                      \
                "Betriebsdurchfluss multipliziert mit Betriebsdichte"

#define  help_totalizer_flow_value                                          \
            "|001Totalizer. Integral of operating flow or mass flow "       \
                "- depends from flow mode."                                 \
            "|049Zhler. Integral des Betriebs- oder Massedurchflusses "    \
                "- abhngig von der Betriebsart"


#define  KODENUMMER  5400

#define  device_busy        "Device Busy"

#define  blnk               ""

#define   display_mode                      \
        {  0, "|001Qv operation"            \
              "|049Qv Betrieb"       },     \
        {  1, "|001Percent"                 \
              "|049Prozent"          },     \
        {  2, "|001Totalizer"               \
              "|049Zhler"           },     \
        {  3, "|001Position"                \
              "|049Position"         }


#define units_flow_volume                     \
                                              \
        UNITS_CODE (24 ),        /* l/s   */  \
        UNITS_CODE (17 ),        /* l/m   */  \
        UNITS_CODE (138),        /* l/h   */  \
                                              \
        UNITS_CODE (28 ),        /* m3/s  */  \
        UNITS_CODE (131),        /* m3/m  */  \
        UNITS_CODE (19 ),        /* m3/h  */  \
        UNITS_CODE (29 ),        /* m3/d  */  \
                                              \
        UNITS_CODE (26 ),        /* ft3/s */  \
        UNITS_CODE (15 ),        /* ft3/m */  \
        UNITS_CODE (130),        /* ft3/h */  \
        UNITS_CODE (27 ),        /* ft3/d */  \
                                              \
        UNITS_CODE (22 ),        /* ugl/s */  \
        UNITS_CODE (16 ),        /* ugl/m */  \
        UNITS_CODE (136),        /* ugl/h */  \
                                              \
        UNITS_CODE (137),        /* igl/s */  \
        UNITS_CODE (18 ),        /* igl/m */  \
        UNITS_CODE (30 ),        /* igl/h */  \
        UNITS_CODE (31 ),        /* igl/d */  \
                                              \
        UNITS_CODE (132),        /* bbl/s */  \
        UNITS_CODE (133),        /* bbl/m */  \
        UNITS_CODE (134),        /* bbl/h */  \
        UNITS_CODE (135)         /* bbl/d */


#define units_flow_mass                       \
                                              \
        UNITS_CODE (70 ),         /* g/s  */  \
        UNITS_CODE (71 ),         /* g/m  */  \
        UNITS_CODE (72 ),         /* g/h  */  \
                                              \
        UNITS_CODE (73 ),         /* kg/s */  \
        UNITS_CODE (74 ),         /* kg/m */  \
        UNITS_CODE (75 ),         /* kg/h */  \
        UNITS_CODE (76 ),         /* kg/d */  \
                                              \
        UNITS_CODE (77 ),         /* t/m  */  \
        UNITS_CODE (78 ),         /* t/h  */  \
        UNITS_CODE (79 ),         /* t/d  */  \
                                              \
        UNITS_CODE (80 ),         /* lb/s */  \
        UNITS_CODE (81 ),         /* lb/m */  \
        UNITS_CODE (82 ),         /* lb/h */  \
        UNITS_CODE (83 )          /* lb/d */


#define units_total_volume                    \
                                              \
        UNITS_CODE (41 ),         /* l   */   \
        UNITS_CODE (43 ),         /* m3  */   \
        UNITS_CODE (112),         /* ft3 */   \
        UNITS_CODE (40 ),         /* ugl */   \
        UNITS_CODE (42 ),         /* igl */   \
        UNITS_CODE (46 )          /* bbl */

#define units_total_mass                      \
                                              \
        UNITS_CODE (60 ),         /* g  */    \
        UNITS_CODE (61 ),         /* kg */    \
        UNITS_CODE (62 ),         /* t  */    \
        UNITS_CODE (63 )          /* lb */

/*
############################################################################
##                                                                        ##
##                           INCLUDE + IMPORT                             ##
##                                                                        ##
############################################################################
*/

#include "macros.ddl"
#include "bi_codes.h"


/*
 * Common Tables
 */


IMPORT STANDARD _TABLES, DEVICE_REVISION 10, DD_REVISION 1
{
  VARIABLE units_code;
	VARIABLE company_identification_code;
	VARIABLE write_protect_code;
}


/*
 * Universal Commmands
 */

IMPORT STANDARD _UNIVERSAL, DEVICE_REVISION 5, DD_REVISION 1
{
  EVERYTHING;

  REDEFINITIONS
  {
    VARIABLE manufacturer_id
  	{
     	REDEFINE TYPE ENUMERATED
    	{
      	{ 26, "ABB" }
     	}
    }

    VARIABLE private_label_distributor
    {
    	REDEFINE TYPE ENUMERATED
    	{
      		{ 26, "ABB" }
    	}
    }
    
    VARIABLE device_type
    {
      REDEFINE TYPE ENUMERATED
      {
        { 27, "AM5400"    }
      }
    }

    VARIABLE response_code
    {
      REDEFINE CLASS USER_INTERFACE;
    }

  }
}



/*
 * Common Commmands
 */

IMPORT STANDARD _COMMON_PRACTICE, DEVICE_REVISION 7, DD_REVISION 1
{
  VARIABLE xmtr_specific_status_0;
  VARIABLE xmtr_specific_status_1;

  VARIABLE transmitter_variable_code_1;
  VARIABLE transmitter_variable_code_2;
  VARIABLE transmitter_variable_code_3;
  VARIABLE transmitter_variable_code_4;


  /* COMMAND read_transmitter_variables;                command 33  */
  COMMAND write_pv_damping_value;                  /*  command 34  */
  COMMAND write_pv_range_values;                   /*  command 35  */
  COMMAND reset_configuration_change_flag;         /*  command 38  */
  COMMAND enter_exit_fixed_pv_current_mode;        /*  command 40  */
  COMMAND trim_pv_current_dac_zero;                /*  command 45  */
  COMMAND trim_pv_current_dac_gain;                /*  command 46  */
  COMMAND read_additional_transmitter_status;      /*  command 48  */


  METHOD loop_test;
  METHOD dac_trim;
  METHOD leave_fixed_current_mode;
  METHOD return_to_normal;


	REDEFINITIONS
	{
  /*
        VARIABLE xmtr_specific_status_0
        {
            REDEFINE LABEL "Fehlerregister 2";
            REDEFINE TYPE BIT_ENUMERATED
            {
                { 0x01,  "Temperatur"       , PROCESS  & CORRECTABLE & DETAIL }
            }
        }
    */
    VARIABLE xmtr_specific_status_0
    {
      REDEFINE LABEL  "|001Error register"
                      "|049Fehlerregister";
      REDEFINE TYPE BIT_ENUMERATED
      {
        { 0x02, "|001Viscosity"
                "|049Viskositt"        , HARDWARE & CORRECTABLE & DETAIL },
        { 0x04, "|001Angle"
                "|049Winkelgeber"       , HARDWARE & CORRECTABLE & DETAIL },
        { 0x08, "|001Flowrate > 110%"
                "|049Durchfluss > 110%" , PROCESS  & CORRECTABLE & DETAIL },
/*
        { 0x10,  "Ex.Ausgangsabsch" , PROCESS  & CORRECTABLE & DETAIL },
  */
        { 0x20, "|001Data base"
                "|049EEPROM"            , HARDWARE & CORRECTABLE & DETAIL },
        { 0x40, "|001Totalizer defective"
                "|049Zhler zerstrt"   , HARDWARE & CORRECTABLE & DETAIL }
/*
        { 0x80,  "Druck"            , PROCESS  & CORRECTABLE & DETAIL }
  */
      }
    }

    VARIABLE xmtr_specific_status_1
    {
      REDEFINE LABEL  "|001Status register"
                      "|049Statusregister";
      REDEFINE TYPE BIT_ENUMERATED
      {
        { 0x01, "|001Viscosity"
                "|049Imp.Wertig. begrenzt"  , HARDWARE & CORRECTABLE & DETAIL },
        { 0x02, "|001Angle"
                "|049Imp.Breite begrenzt"   , HARDWARE & CORRECTABLE & DETAIL },
        { 0x04, "|001Alarm"
                "|049Alarm"                 , PROCESS  & CORRECTABLE & DETAIL },
        { 0x08, "|001Max. Alarm"
                "|049max. Alarm"            , PROCESS  & CORRECTABLE & DETAIL },
        { 0x10, "|001Min. Alarm"
                "|049min. Alarm"            , PROCESS  & CORRECTABLE & DETAIL },
        { 0x20, "|001Totl. unit limited"
                "|049Zhl.Einh. begrenzt" , PROCESS  & CORRECTABLE & DETAIL },
        { 0x40, "|001Functiontest"
                "|049Funktionstest"         , PROCESS & CORRECTABLE & DETAIL }
      }
    }

        /*
        VARIABLE xmtr_specific_status_2
        {
            REDEFINE LABEL "Statusregister 1";
            REDEFINE TYPE BIT_ENUMERATED
            {
                { 0x01,  "Ex. Zhlerreset"  , HARDWARE & CORRECTABLE & DETAIL },
                { 0x02,  "Ex Abschaltung"   , HARDWARE & CORRECTABLE & DETAIL },
                { 0x04,  "Alarm"            , HARDWARE & CORRECTABLE & DETAIL },
                { 0x08,  "Max-Alarm"        , PROCESS  & CORRECTABLE & DETAIL },
                { 0x10,  "Min-Alarm"        , PROCESS  & CORRECTABLE & DETAIL },
                { 0x20,  "Schleichmenge"    , HARDWARE & CORRECTABLE & DETAIL },
                { 0x40,  "Selbsttest-Mode"  , HARDWARE & CORRECTABLE & DETAIL },
                { 0x80,  "Remote Mode"      , PROCESS  & CORRECTABLE & DETAIL }
            }
        }
          */

    COMMAND read_additional_transmitter_status  /* command 48 */
    {
      REDEFINE TRANSACTION
      {
        REQUEST
        {}
        REPLY
        {
          response_code ,device_status
          ,xmtr_specific_status_0
          ,xmtr_specific_status_1
/*
                    xmtr_specific_status_2
  */
        }
      }
    }

  }
}



IMPORT STANDARD _RMTFLOW, DEVICE_REVISION 5, DD_REVISION 2
{
    VARIABLE flow_analog_value;
    VARIABLE flow_percent_range;
    VARIABLE flow_upper_sensor_limit;
    VARIABLE flow_lower_sensor_limit;
    VARIABLE flow_minimum_span;
    VARIABLE flow_alarm_select;
    VARIABLE transfer_function;
    VARIABLE flow_upper_range_value;
    VARIABLE flow_lower_range_value;
    VARIABLE flow_damping_value;
    VARIABLE flow_sensor_serial_number;


    MENU hot_key;
    MENU root_menu;                 /* root_menu                            */
    MENU device_setup;              /* I- device_setup                      */
    MENU process_variables;         /* I  I- process_variables              */
    MENU diag_service;              /* I  I- diag_service                   */
    MENU detailed_setup;            /* I  I- detailed_setup                 */
    MENU basic_setup;               /* I  I  I- basic_setup                 */
    MENU flow_root_sensor;          /* I  I  I- flow_root_sensor            */
    MENU flow_root_input_block;     /* I  I  I- flow_root_input_block       */
    MENU flow_root_outputs;         /* I  I  I- flow_root_outputs           */
    MENU flow_root_analog_out;      /* I  I     I- flow_root_analog_out     */
    MENU flow_root_hart;            /* I  I     I- flow_root_hart           */
                                    /* I  I- special_commands               */


    REDEFINITIONS
    {

        MENU hot_key
        {
            REDEFINE ITEMS
            {
                root_menu                       /* menu */
            }
        }


        MENU device_setup
        {
            REDEFINE ITEMS
            {
                process_variables,              /* menu */
                /* process_variables_2,             menu */
                diag_service,                   /* menu */
                detailed_setup,                 /* menu */
                special_commands                /* menu */
            }
        }

        MENU process_variables
        {
            REDEFINE ITEMS
            {
                /*-------------------------------------------------------
                PV is defined as dynamic_variables[PRIMARY] in macros.ddl.
                This refers to process_operating_flow.
                DIGITAL_VALUE of process_operating_flow refers to
                operating_flow_value.
                Menu-name is the description of primary in dynamic_variables.
                This is "Qv". When this is selected, the label of
                operating_flow_value appears. This is "Operating Flow Qv".
                -------------------------------------------------------*/
                PV.DIGITAL_VALUE        (DISPLAY_VALUE, READ_ONLY),
                SV.DIGITAL_VALUE        (DISPLAY_VALUE, READ_ONLY),
                /*
                TV.DIGITAL_VALUE        (DISPLAY_VALUE, READ_ONLY),
                */
                QV.DIGITAL_VALUE        (DISPLAY_VALUE, READ_ONLY)
                ,flow_analog_value (DISPLAY_VALUE, READ_ONLY)   /* variable */

                /*-------------------------------------------------------
                Menu-name is the label of operating_flow_value. This is
                "Operating Flow Qv". Because this is to long, no number
                appears. Therefor it is better to use PV.DIGITAL_VALUE.
                -------------------------------------------------------*/
                /* operating_flow_value (DISPLAY_VALUE, READ_ONLY),  */
                /* mass_flow_value (DISPLAY_VALUE, READ_ONLY),       */
                /* totalizer_value (DISPLAY_VALUE, READ_ONLY),       */
                /* frequency_value (DISPLAY_VALUE, READ_ONLY)        */
            }
        }

        MENU diag_service
        {
            REDEFINE ITEMS
            {
             /* test_device */                      /* menu */
                loop_test,                          /* common-method */
                dac_trim,                           /* common-method  (OPTIONAL) */

                xmtr_specific_status_0 (DISPLAY_VALUE, READ_ONLY),
                xmtr_specific_status_1 (DISPLAY_VALUE, READ_ONLY),
/*
                xmtr_specific_status_2 (DISPLAY_VALUE, READ_ONLY)
  */
                reset_config_changed_flag
            }
        }

        MENU detailed_setup
        {
            REDEFINE ITEMS
            {
                basic_setup,                               /* menu */
                flow_root_sensor,                          /* menu */
                flow_root_input_block,                     /* menu */
                flow_root_outputs                          /* menu */
            }
        }

        MENU basic_setup
        {
            REDEFINE ITEMS
            {

                tag (DISPLAY_VALUE),                    /* variable */
                descriptor (DISPLAY_VALUE),             /* variable */
                message (DISPLAY_VALUE),                /* variable */
                date (DISPLAY_VALUE)                    /* variable */
            }
        }

        MENU flow_root_sensor
        {
            REDEFINE ITEMS
            {
                PV.DIGITAL_VALUE (DISPLAY_VALUE, READ_ONLY),
                flow_lower_sensor_limit (DISPLAY_VALUE, READ_ONLY),
                flow_upper_sensor_limit (DISPLAY_VALUE, READ_ONLY),
                flow_minimum_span (DISPLAY_VALUE, READ_ONLY),
                flow_sensor_serial_number (DISPLAY_VALUE, READ_ONLY)
            }
        }

        MENU flow_root_input_block
        {
            REDEFINE ITEMS
            {
                flow_percent_range (DISPLAY_VALUE, READ_ONLY),  /* variable */
                flow_upper_range_value (DISPLAY_VALUE),
                flow_lower_range_value (DISPLAY_VALUE, READ_ONLY),
                flow_damping_value (DISPLAY_VALUE)
            }
        }

        MENU flow_root_outputs
        {
            REDEFINE ITEMS
            {
                flow_root_analog_out,                           /* menu */
                flow_root_hart                                  /* menu */
            }
        }

        MENU flow_root_analog_out
        {
            REDEFINE ITEMS
            {
                flow_analog_value (DISPLAY_VALUE, READ_ONLY),   /* variable */
                flow_alarm_select (DISPLAY_VALUE),              /* variable */                     /* method */
                loop_test,                                      /* method    */
                dac_trim                                        /* method  */
             /* scaled_dac_trim */                              /* method  */
            }
        }

        MENU flow_root_hart
        {
            REDEFINE ITEMS
            {
                /* Changed: add (DISPLAY_VALUE) to polling_address,   */
                /* polling_address in review has also (DISPLAY_VALUE) */

                polling_address (DISPLAY_VALUE),    /* this is write only!! */
                request_preambles (DISPLAY_VALUE)
             /* burst_mode_select (DISPLAY_VALUE),   */         /* variable */
             /* burst_command_number (DISPLAY_VALUE) */         /* variable */
            }
        }


    }
}




/*
############################################################################
##                                                                        ##
##                                 Menus                                  ##
##                                                                        ##
############################################################################
*/
                        /*

                        MENU process_variables_2
                        {
                            LABEL "|001Process Variab. 2"
                                  "|049Prozess Variab. 2";
                            ITEMS
                            {
                                temperatur_wert      (DISPLAY_VALUE, READ_ONLY),
                                druck_wert           (DISPLAY_VALUE, READ_ONLY),
                                betriebsdichte_wert  (DISPLAY_VALUE, READ_ONLY),
                                winkel_wert          (DISPLAY_VALUE, READ_ONLY),
                                Qw_wert              (DISPLAY_VALUE, READ_ONLY)
                            }
                        }
                          */

/* special      */      MENU special_commands
/* I            */      {
/* I            */          LABEL "|001Special Commands"
                                  "|049Spez. Kommandos";
/* I            */          ITEMS
/* I            */          {
/* I            */              menu_aufnehmer,
/* I            */              menu_berechnung,
/* I            */              menu_einaus,
/* I            */              menu_diagnose,
/* I            */              menu_abgleich
/* I            */          }
/* I            */      }
/* I            */
/* I            */
/* I-aufnehmer  */      MENU menu_aufnehmer
/* I I          */      {
/* I I          */          LABEL "|001Primary"
                                  "|049Aufnehmer";
/* I I          */          ITEMS
/* I I          */          {
/* I I          */              geraetenummer        (DISPLAY_VALUE),
/* I I          */              menu_messbereiche
/* I I          */          }
/* I I          */      }
/* I I          */
/* I I          */
/* I I-messber. */      MENU menu_messbereiche
/* I            */      {
/* I            */          LABEL "|001Ranges"
                                  "|049Messbereiche";
/* I            */          ITEMS
/* I            */          {
/* I            */              Qmax_medium          (DISPLAY_VALUE),
/* I            */              Qmax                 (DISPLAY_VALUE),
/* I            */              schleichmenge        (DISPLAY_VALUE)
/* I            */          }
/* I            */      }
/* I            */
/* I            */
/* I            */
/* I-berechnung */      MENU menu_berechnung
/* I            */      {
/* I            */          LABEL "|001Calculation"
                                  "|049Berechnung";
/* I            */          ITEMS
/* I            */          {
/* I            */              betriebsart          (DISPLAY_VALUE),
/* I            */              viskositaet          (DISPLAY_VALUE),
/* I                              betriebs_temp        (DISPLAY_VALUE), */
/* I                              betriebs_druck       (DISPLAY_VALUE), */
/* I                              normzustand          (DISPLAY_VALUE), */
/* I                              gasberechnung        (DISPLAY_VALUE), */
/* I                              ausgleichskoeff      (DISPLAY_VALUE), */
/* I                              VdW_gastabelle       (DISPLAY_VALUE), */
/* I                              VdW_a                (DISPLAY_VALUE), */
/* I                              VdW_b                (DISPLAY_VALUE), */
/* I            */              normdichte           (DISPLAY_VALUE),
/* I            */              betriebsdichte       (DISPLAY_VALUE)
/* I            */          }
/* I            */      }
/* I            */
/* I            */
/* I            */
/* I-einaus     */      MENU menu_einaus
/* I I          */      {
/* I I          */          LABEL "|001In/Output"
                                  "|049Ein/Ausgnge";
/* I I          */          ITEMS
/* I I          */          {
/* I I          */               menu_anzeige
/* I I          */              ,menu_einheiten
/* I I          */              ,menu_stromausgang
/* I I          */              ,menu_zaehler
/* I I          */              ,menu_impulsausgang
/* I I          */              ,menu_alarm
/* I I                            menu_druckeingang,  */
/* I I                            menu_pt_modul,      */
/* I I                            menu_kommunikation, */
/* I I          */              ,menu_signalisierung
/* I I          */          }
/* I I          */      }
/* I I          */
/* I I          */
/* I I-anzeige  */      MENU menu_anzeige
/* I I          */      {
/* I I          */          LABEL "|001Display"
                                  "|049Anzeige";
/* I I          */          ITEMS
/* I I          */          {
/* I I          */              sprache              (DISPLAY_VALUE),
/* I I          */              anzeige_1_zeile      (DISPLAY_VALUE),
/* I I          */              anzeige_2_zeile      (DISPLAY_VALUE),
/* I I          */              anzeige_2_zeile_mpx  (DISPLAY_VALUE),
/* I I          */              multiplex            (DISPLAY_VALUE)
/* I I          */          }
/* I I          */      }
/* I I          */
/* I I          */
/* I I-einheit  */      MENU menu_einheiten
/* I I          */      {
/* I I          */          LABEL "|001Units"
                                  "|049Einheiten";
/* I I          */          ITEMS
/* I I          */          {
/* I I          */            einheit_Qv           (DISPLAY_VALUE),
/* I I          */            einheit_Qm           (DISPLAY_VALUE),
/* I I                          einheit_Q            (DISPLAY_VALUE), */
/* I I          */            einheit_Zv           (DISPLAY_VALUE),
/* I I          */            einheit_Zm           (DISPLAY_VALUE),
/* I I                          einheit_Z            (DISPLAY_VALUE), */
/* I I                          einheit_temp         (DISPLAY_VALUE), */
/* I I                          einheit_druck        (DISPLAY_VALUE), */
/* I I                          einheit_dichte       (DISPLAY_VALUE)  */
/* I I          */            dichte_einheit       (DISPLAY_VALUE)
/* I I          */          }
/* I I          */      }
/* I I          */
/* I I          */
/* I I-stromaus.*/      MENU menu_stromausgang
/* I I          */      {
/* I I          */          LABEL "|001Current output"
                                  "|049Stromausgang";
/* I I          */          ITEMS
/* I I          */          {
/* I I                          stromausgang         (DISPLAY_VALUE), */
/* I I                          Iout_alarm           (DISPLAY_VALUE), */
/* I I          */            flow_alarm_select    (DISPLAY_VALUE),
/* I I                          daempfung            (DISPLAY_VALUE)  */
/* I I          */            flow_damping_value   (DISPLAY_VALUE)
/* I I          */          }
/* I I          */      }
/* I I          */
/* I I          */
/* I I-zaehler  */      MENU menu_zaehler
/* I I          */      {
/* I I          */          LABEL "|001Totalizer"
                                  "|049Zhler";
/* I I          */          ITEMS
/* I I          */          {
/* I I          */              totalizer_value      (DISPLAY_VALUE, READ_ONLY),
/* I I          */              ueberlauf            (DISPLAY_VALUE, READ_ONLY),
/* I I          */              reset_totalizer
/* I I          */          }
/* I I          */      }
/* I I          */
/* I I          */
/* I I-impulsa. */      MENU menu_impulsausgang
/* I I          */      {
/* I I          */          LABEL "|001Pulse output"
                                  "|049Impulsausgang";
/* I I          */          ITEMS
/* I I          */          {
/* I I          */              impuls_faktor        (DISPLAY_VALUE),
/* I I          */              impulsbreite         (DISPLAY_VALUE)
/* I I          */          }
/* I I          */      }
/* I I          */
/* I I          */
/* I I-alarm    */      MENU menu_alarm
/* I I          */      {
/* I I          */          LABEL "|001Alarm"
                                  "|049Alarm";
/* I I          */          ITEMS
/* I I          */          {
/* I I          */              max_alarm            (DISPLAY_VALUE),
/* I I          */              min_alarm            (DISPLAY_VALUE)
/* I I          */          }
/* I I          */      }
/* I I          */
/* I I          */
/* I I-drucke.        MENU menu_druckeingang
 I I                {
 I I                    LABEL "Druckeingang";
 I I                    ITEMS
 I I                    {
 I I                        druck_0              (DISPLAY_VALUE),
 I I                        druck_100            (DISPLAY_VALUE)
 I I                    }
 I I                }
 I I
 I I
 I I-pt_modul       MENU menu_pt_modul
 I I                {
 I I                    LABEL "PT-Modul";
 I I                    ITEMS
 I I                    {
 I I                        temp_messen          (DISPLAY_VALUE),
 I I                        druck_messen         (DISPLAY_VALUE)
 I I                    }
 I I                }
 I I
 I I          */
/* I I-schnitts.      MENU menu_schnittstelle                          */
/* I                  {                                                */
/* I                      LABEL "|001Interface"                        */
/* I                            "|049Schnittstelle";                   */
/* I                      ITEMS                                        */
/* I                      {                                            */
/* I                          kommunikation        (DISPLAY_VALUE), */
/* I                          tag                  (DISPLAY_VALUE)  */
/* I                          baudrate             (DISPLAY_VALUE), */
/* I                          geraeteadresse       (DISPLAY_VALUE) */
/* I                          druckertyp           (DISPLAY_VALUE) */
/* I                          signalisierung        (DISPLAY_VALUE) */
/* I                      }                                            */
/* I                  }                                                */
/* I                                                                   */
/* I            */
/* I I-signalis.*/      MENU menu_signalisierung
/* I            */      {
/* I            */          LABEL "|001HW configuration"
/* I            */                "|049HW Konfiguration";
/* I            */          ITEMS
/* I            */          {
/* I            */            signalisierung        (DISPLAY_VALUE)
/* I            */          }
/* I            */      }
/* I            */
/* I            */
/* I-diagnose   */      MENU menu_diagnose
/* I I          */      {
/* I I          */          LABEL "|001Diagnostic"
/* I I          */                "|049Diagnose";
/* I I          */          ITEMS
/* I I          */          {
/* I I                          menu_fehlerregister */
/* I            */            xmtr_specific_status_0 (DISPLAY_VALUE, READ_ONLY)
/* I            */            xmtr_specific_status_1 (DISPLAY_VALUE, READ_ONLY)
/* I            */            reset_config_changed_flag
/* I I          */          }
/* I I          */      }
/* I I          */
/* I I          */
/* I I-fehlerr. */      MENU menu_fehlerregister
/* I            */      {
/* I            */          LABEL "|001Error register"
/* I I          */                "|049Fehlerregister";
/* I            */          ITEMS
/* I            */          {
/* I                            netzausfall            (DISPLAY_VALUE, READ_ONLY), */
/* I            */            xmtr_specific_status_0 (DISPLAY_VALUE, READ_ONLY),
/* I            */            xmtr_specific_status_1 (DISPLAY_VALUE, READ_ONLY),
/* I                            xmtr_specific_status_2 (DISPLAY_VALUE, READ_ONLY) */
/* I            */            reset_config_changed_flag
/* I            */          }
/* I            */      }
/* I            */
/* I            */
/* I            */
/* I-abgleich   */      MENU menu_abgleich
/*   I          */      {
/*   I          */          LABEL "|001Adjust"
                                  "|049Abgleich";
/*   I          */          ITEMS
/*   I          */          {
/*   I          */              kodenummer           (DISPLAY_VALUE),
/*   I          */              menu_abgleich_strom,
/*   I          */              menu_abgleich_aufnehmer
/*   I          */          }
/*   I          */      }
/*   I          */
/*   I          */
/*   I-strom    */      MENU menu_abgleich_strom
/*   I          */      {
/*   I          */          LABEL "|001Current output"
                                  "|049Stromausgang";
/*   I          */          ITEMS
/*   I          */          {
/*   I          */              abgl_Iout_4mA        (DISPLAY_VALUE),
/*   I          */              abgl_Iout_20mA       (DISPLAY_VALUE)
/*   I          */          }
/*   I          */      }
/*   I          */
/*   I          */
/*   I-aufn.    */      MENU menu_abgleich_aufnehmer
/*     I        */      {
/*     I        */          LABEL "|001Primary"
                                  "|049Aufnehmer";
/*     I        */          ITEMS
/*     I        */          {
/*     I        */              Qmax_wasser          (DISPLAY_VALUE),
/*     I        */              sk_dichte            (DISPLAY_VALUE),
/*     I        */              viskositaetszahl     (DISPLAY_VALUE)
/*     I        */              menu_winkelgeber,
/*     I        */              menu_meister_punkte,
/*     I        */              menu_pruefling_punkte
/*     I        */          }
/*     I        */      }
/*     I        */
/*     I        */
/*     I-wink.  */      MENU menu_winkelgeber
/*     I        */      {
/*     I        */          LABEL "|001Angle primary"
                                  "|049Winkelgeber";
/*     I        */          ITEMS
/*     I        */          {
/*     I        */              winkel_0_grad        (DISPLAY_VALUE),
/*     I        */              winkel_90_grad       (DISPLAY_VALUE)
/*     I        */          }
/*     I        */      }
/*     I        */
/*     I        */
/*     I-meist. */      MENU menu_meister_punkte
/*     I        */      {
/*     I        */          LABEL "|001Master points"
                                  "|049Meister-Punkte";
/*     I        */          ITEMS
/*     I        */          {
/*     I        */              M1                   (DISPLAY_VALUE),
/*     I        */              M2                   (DISPLAY_VALUE),
/*     I        */              M3                   (DISPLAY_VALUE),
/*     I        */              M4                   (DISPLAY_VALUE),
/*     I        */              M5                   (DISPLAY_VALUE),
/*     I        */              M6                   (DISPLAY_VALUE),
/*     I        */              M7                   (DISPLAY_VALUE),
/*     I        */              M8                   (DISPLAY_VALUE),
/*     I        */              M9                   (DISPLAY_VALUE),
/*     I        */              M10                  (DISPLAY_VALUE)
/*     I        */          }
/*     I        */      }
/*     I        */
/*     I        */
/*     I-pruef. */      MENU menu_pruefling_punkte
/*              */      {
/*                        LABEL "|001d.u.t-points"    */
/*                        LABEL "|001test object-points"    */
/*              */          LABEL "|001Primary-points"
                                  "|049Prfling-Punkte";
/*              */          ITEMS
/*              */          {
/*              */              P1                   (DISPLAY_VALUE),
/*              */              P2                   (DISPLAY_VALUE),
/*              */              P3                   (DISPLAY_VALUE),
/*              */              P4                   (DISPLAY_VALUE),
/*              */              P5                   (DISPLAY_VALUE),
/*              */              P6                   (DISPLAY_VALUE),
/*              */              P7                   (DISPLAY_VALUE),
/*              */              P8                   (DISPLAY_VALUE),
/*              */              P9                   (DISPLAY_VALUE),
/*              */              P10                  (DISPLAY_VALUE)
/*              */          }
/*              */      }




/*
############################################################################
##                                                                        ##
##                            Unit-VARIABLEs                              ##
##                                                                        ##
############################################################################
*/

VARIABLE flow_unit
{
  LABEL "|001Flow Unit"
        "|049Durchflusseinheit";
  HELP  "|001Flow unit depends on operating mode"
        "|049Durchflusseinheit in Abhngigkeit von der Betriebsart";
  CLASS INPUT;
  HANDLING READ & WRITE;

  TYPE ENUMERATED
  {
                                      /* volumen */
    units_flow_volume,
                                      /* masse */
    units_flow_mass
  }
}

UNIT flow_unit_relation
{
  flow_unit
  /* einheit_Q */
  :actual_flow_value
  ,Qw_wert
  ,flow_upper_sensor_limit
  ,flow_lower_sensor_limit
  ,flow_minimum_span
  ,flow_upper_range_value
  ,flow_lower_range_value
  ,Qmax_medium
  ,Qmax
}

/*------------------------------------------------------------------------

VARIABLE mass_flow_units
{
  HELP "Mass Flow Unit Help";
  CLASS INPUT;
  LABEL "|001Mass Flow Unit"
        "|049Massendurchfluss Einheit";
  HANDLING READ & WRITE;

  TYPE ENUMERATED
  {
  */
/*    units_flow_mass                 */
/*
  }
}

UNIT mass_flow_unit_relation
{
  mass_flow_units
  :mass_flow_value
}

------------------------------------------------------------------------*/

VARIABLE totalizer_units
{
  LABEL "|001Totl. Unit"
        "|049Einheit Zhler";
  HELP  "|001Totalizer unit depends on operating mode"
        "|049Zhlereinheit in Abhngigkeit von der Betriebsart";
  CLASS DEVICE;
  HANDLING READ & WRITE;

  TYPE ENUMERATED
  {
    units_total_volume,

    units_total_mass
  }
}

/*------------------------------------------------------------------------*/

VARIABLE dichte_einheit
{        
  LABEL "|001Density Unit"
        "|049Einheit Dichte";
  HELP  "|001Unit for all densityvariables"
        "|049Einheit fr alle Dichtevariablen";
  CLASS INPUT;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
  {
    UNITS_CODE (95),            /* g/ml   */
    UNITS_CODE (91),            /* g/cm3  */
    UNITS_CODE (97),            /* g/l    */
    UNITS_CODE (96),            /* kg/l   */
    UNITS_CODE (92),            /* kg/m3  */
    UNITS_CODE (94),            /* lb/ft3 */
    UNITS_CODE (93)             /* lb/ugl */
  }
}

UNIT dichte_einheit_relation
{
    dichte_einheit:
    normdichte,
    betriebsdichte,
    sk_dichte
/*
    betriebsdichte_wert,
  */
}

/*------------------------------------------------------------------------

VARIABLE druck_einheit
{
  LABEL "Pressure Unit";
  HELP "Pressure Unit Help";
  CLASS INPUT;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
  {
*/
/*    UNITS_CODE (7),             bar  */
/*    UNITS_CODE (6)              PSI  */
/*
  }
}

UNIT druck_einheit_relation
{
  druck_einheit:
  druck_wert
  ,druck_0
  ,druck_100
  betriebs_druck
}

------------------------------------------------------------------------

VARIABLE temperatur_einheit
{
  LABEL "|001Temperature unit"
        "|049Temperatur Einheit";
  HELP "Temperature Unit Help";
  CLASS INPUT;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
  {
    UNITS_CODE (32),            -* C *-
    UNITS_CODE (33)             -* F *-
  }
}

UNIT temperatur_einheit_relation
{
  temperatur_einheit:
  temperatur_wert
-*
  ,betriebs_temp
  *-
}

------------------------------------------------------------------------*/

VARIABLE strom_einheit
{
  CLASS INPUT;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
  {
    UNITS_CODE (39)            /* mA */
  }
}

UNIT strom_einheit_relation
{
  strom_einheit:
  abgl_Iout_4mA,
  abgl_Iout_20mA
}

/*------------------------------------------------------------------------*/

VARIABLE prozent_einheit
{
  CLASS INPUT;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
  {
    UNITS_CODE (57)            /* % */
  }
}

UNIT prozent_einheit_relation
{
  prozent_einheit
  :schleichmenge
  ,max_alarm
  ,min_alarm
  ,M1
  ,M2
  ,M3
  ,M4
  ,M5
  ,M6
  ,M7
  ,M8
  ,M9
  ,M10
  ,P1
  ,P2
  ,P3
  ,P4
  ,P5
  ,P6
  ,P7
  ,P8
  ,P9
  ,P10
  ,winkel_wert
}

/*------------------------------------------------------------------------*/

VARIABLE zeit_einheit
{
  CLASS INPUT;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
  {
    UNITS_CODE (51)            /* sek */
  }
}

  /*
UNIT zeit_einheit_relation
{
  zeit_einheit:
  daempfung
  flow_damping_value
}
  */

/*------------------------------------------------------------------------*/

VARIABLE keine_einheit
{
  CLASS INPUT;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
  {
    {250,  [not_used]    }
  }
}

/*                              wichtig, dass auskommentiert!!!
UNIT keine_einheit_relation
{
    keine_einheit:
    winkel_wert
    ,geraetenummer
    ,kodenummer
    ,ueberlauf
    ,geraeteadresse
}
*/

/*------------------------------------------------------------------------*/

VARIABLE spezielle_einheit
{
  CLASS INPUT;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
  {
    UNITS_CODE(253)
  }
}

/*                              wichtig, dass auskommentiert!!!
UNIT spezielle_einheit_relation
{
    spezielle_einheit:
    viskositaet
    ,ausgleichskoeff
    ,VdW_a
    ,VdW_b
    ,vol_ausdehnung
    ,impulsbreite
    ,viskositaetszahl
}
*/





/*
############################################################################
##                                                                        ##
##                              VARIABLE                                  ##
##                                                                        ##
############################################################################
*/



VARIABLE actual_flow_value
{
  LABEL "|001Actual Flow Qv"
        "|049Akt. Durchfluss Qv";
  HELP  help_actual_flow_value;
  CLASS DYNAMIC & INPUT;

  TYPE  FLOAT
  {
    DISPLAY_FORMAT ".2f";
  }
}

COLLECTION OF VARIABLE process_actual_flow
{
  MEMBERS
  {
  /* Index          Item                 Description           Help */
    DIGITAL_VALUE, actual_flow_value,   [blank],              [blank];
    DIGITAL_UNITS, flow_unit,           [units],              [blank];
    /*
    DIGITAL_UNITS, einheit_Q,           [units],              [blank];
    */
    ANALOG_VALUE , flow_analog_value,   [analog_output_value],[analog_output_help];
    PERCENT_RANGE, flow_percent_range,  [percent_of_range],   [percent_of_range_help];

    /* Sensor Information */
    SENSOR_UNITS,  flow_unit,           [sensor_unit],        [sensor_minspan_unit_help];
    /*
    SENSOR_UNITS,  einheit_Q,           [sensor_unit],        [sensor_minspan_unit_help];
    */
    UPPER_SENSOR_LIMIT,   flow_upper_sensor_limit,  [usl],                  [upper_sensor_limit_help];
    LOWER_SENSOR_LIMIT,   flow_lower_sensor_limit,  [lsl],                  [lower_sensor_limit_help];
    MINIMUM_SPAN,         flow_minimum_span,        [minimum_span],         [minimum_span_help];
    SENSOR_SERIAL_NUMBER, flow_sensor_serial_number,[sensor_serial_number], [sensor_serial_number_help];

    /* Output Information */
    ALARM_CODE,        flow_alarm_select, [alarm_select],     [alarm_code_help];
    TRANSFER_FUNCTION, transfer_function, [transfer_function],[transfer_function_help];
    RANGE_UNITS,       flow_unit,         [range_units],      [range_units_help];
    /*
    RANGE_UNITS,       einheit_Q,         [range_units],      [range_units_help];
    */
    UPPER_RANGE_VALUE, flow_upper_range_value,[urv],          [upper_range_value_help];
    LOWER_RANGE_VALUE, flow_lower_range_value,[lrv],          [lower_range_value_help];
    DAMPING_VALUE,     flow_damping_value,    [damping_value],[seconds_damping_value_help];
  }
}

/*------------------------------------------------------------------------

VARIABLE standard_flow_value
{
  LABEL "|001Standard Flow Qn"
        "|049Standard Durchfl. Qn";
  HELP  help_standard_flow_value;
  CLASS DYNAMIC & INPUT;

  TYPE  FLOAT
  {
    DISPLAY_FORMAT ".2f";
  }
}

COLLECTION OF VARIABLE process_standard_flow
{
  MEMBERS
  {
    DIGITAL_VALUE, standard_flow_value,  [blank],     [blank];
    DIGITAL_UNITS, flow_unit,      [units],              [blank];
    DIGITAL_UNITS, einheit_Q,           [units],              [blank];
  }
}

------------------------------------------------------------------------

VARIABLE mass_flow_value
{
  LABEL "|001Mass Flow Qm"
        "|049Massendurchfl. Qm";
  HELP  help_mass_flow_value;
  CLASS DYNAMIC & INPUT;

  TYPE  FLOAT
  {
      DISPLAY_FORMAT ".2f";
  }
}

COLLECTION OF VARIABLE process_mass_flow
{
    MEMBERS
    {
        DIGITAL_VALUE, mass_flow_value,  [blank],     [blank];
        DIGITAL_UNITS, mass_flow_units,  [units],     [units];
        DIGITAL_UNITS, einheit_Q,           [units],              [blank];
    }
}

------------------------------------------------------------------------*/

VARIABLE totalizer_value
{
  LABEL "|001Totl."
        "|049Zhler";
  HELP  help_totalizer_flow_value;
  CLASS DYNAMIC & INPUT;

  TYPE  FLOAT
  {
    DISPLAY_FORMAT ".2f";
  }
}
             
COLLECTION OF VARIABLE process_totalizer
{
  MEMBERS
  {
  /* Index          Item              Description  Help */
    DIGITAL_VALUE, totalizer_value,  [blank],     [blank];
    DIGITAL_UNITS, totalizer_units,  [units],     [blank];
/*    DIGITAL_UNITS, einheit_Z,        [units],     [blank]; */
  }
}

/*------------------------------------------------------------------------

VARIABLE druck_wert
{
  CLASS DYNAMIC & INPUT;
  LABEL "P ";
  HELP  "Hilfe Druck Wert";

  TYPE FLOAT
    {
      DISPLAY_FORMAT ".1f";
    }
}

COLLECTION OF VARIABLE prozess_druck
{
    MEMBERS
    {
        DIGITAL_VALUE, druck_wert    ,   [blank],     [blank];
        DIGITAL_UNITS, druck_einheit ,   [units],     [blank];
    }
}

------------------------------------------------------------------------

VARIABLE temperatur_wert
{
  CLASS DYNAMIC & INPUT;
  LABEL "T ";
  HELP  "Hilfe Temperatur Wert";

  TYPE FLOAT
    {
      DISPLAY_FORMAT ".1f";
    }
}

COLLECTION OF VARIABLE prozess_temperatur
{
    MEMBERS
    {
     -* Index          Item                 Description  Help *-
        DIGITAL_VALUE, temperatur_wert    , [blank],     [blank];
        DIGITAL_UNITS, temperatur_einheit , [units],     [blank];
    }
}

------------------------------------------------------------------------

VARIABLE betriebsdichte_wert
{
  CLASS DYNAMIC & INPUT;
  LABEL "D ";
  HELP  "|001Operating Density"
        "|049Betriebsdichte";

  TYPE FLOAT
    {
      DISPLAY_FORMAT ".4f";
    }
}

COLLECTION OF VARIABLE prozess_betriebsdichte
{
    MEMBERS
    {
        DIGITAL_VALUE, betriebsdichte_wert  ,  [blank],     [blank];
        DIGITAL_UNITS, dichte_einheit       ,  [units],     [blank];
    }
}

------------------------------------------------------------------------*/

VARIABLE winkel_wert
{
  LABEL "W ";
  HELP  "|001Angle value"
        "|049Winkel Wert";
  CLASS DYNAMIC & INPUT;
/*
  CONSTANT_UNIT "Grad";
  */
  TYPE FLOAT
  {
    DISPLAY_FORMAT ".1f";
  }
}

COLLECTION OF VARIABLE prozess_winkel
{
  MEMBERS
  {
   /* Index          Item              Description  Help */
      DIGITAL_VALUE, winkel_wert    ,  [blank],     [blank];
      DIGITAL_UNITS, prozent_einheit , [units],     [blank];
  }
}

/*------------------------------------------------------------------------*/

VARIABLE Qw_wert
{
  CLASS DYNAMIC & INPUT;
  LABEL "Qw";
  HELP  "|001Waterflow Qw"
        "|049Wasserdurchfluss Qw";

  TYPE FLOAT
  {
    DISPLAY_FORMAT ".1f";
  }
}

COLLECTION OF VARIABLE prozess_Qw
{
  MEMBERS
  {
  /* Index          Item              Description  Help */
     DIGITAL_VALUE, Qw_wert        , [blank],     [blank];
     DIGITAL_UNITS, flow_unit,      [units],     [blank];
     /*
     DIGITAL_UNITS, einheit_Q,       [units],     [blank];
     */
  }
}

/*------------------------------------------------------------------------*/


COLLECTION OF VARIABLE process_Qproz
{
  MEMBERS
  {
  /* Index          Item                Description         Help */
    DIGITAL_VALUE,  flow_percent_range, "Q%" /*[percent_of_range]*/ , [percent_of_range_help];
    DIGITAL_UNITS,  prozent_einheit ,   [units],            [blank];
  }
}

/*------------------------------------------------------------------------*/

ARRAY OF COLLECTION transmitter_variables
{
  HELP [transmitter_variable_help];
  ELEMENTS
  {
  /* Index Item                    Description  Help */
     0,    process_actual_flow,    "Qv",        help_actual_flow_value;

     1,    process_totalizer,      "Q ",        help_totalizer_flow_value;
     /*
     1,    process_standard_flow,  "Qn",        help_standard_flow_value;
     2,    process_mass_flow,      "Qm",        help_mass_flow_value;
     3,    process_totalizer,      "Q ",        help_totalizer_flow_value;
     4,    prozess_temperatur,     "T ",        [blank];
     5,    prozess_druck,          "P ",        [blank];
     6,    prozess_betriebsdichte, "W ",        [blank];
       */
     2,    prozess_winkel,         "W ",        [blank];
     3,    process_Qproz,          ""  ,        help_actual_flow_value;
     4,    prozess_Qw,             "Qw",        [blank];
  }
}

/*------------------------------------------------------------------------*/
/* PV is defined as dynamic_variable[PRIMARY] in macros.ddl */

ARRAY OF COLLECTION dynamic_variables
{
  HELP [dynamic_variable_help];

  ELEMENTS
	{
  /* Index     Item                   Description   Help */
    /*
    PRIMARY,  process_actual_flow,   "Q" ,         help_actual_flow_value;
    SECONDARY,process_standard_flow, "Qn",         help_standard_flow_value;
    TERTIARY, process_mass_flow,     "Qm",         help_mass_flow_value;
    FOURTH,   process_totalizer,     "Q ",         help_totalizer_flow_value;

    SECONDARY,process_totalizer,     "Ttl",        help_totalizer_flow_value;
    TERTIARY, prozess_winkel,        "W ",         [blank];
    FOURTH,   process_Qproz,         ""   ,        help_actual_flow_value;
    */
    PRIMARY,  transmitter_variables[0],   "Q" ,    help_actual_flow_value;
    SECONDARY,transmitter_variables[1],   "Ttl",   help_actual_flow_value;
    TERTIARY, transmitter_variables[2],   "",      help_actual_flow_value;
    FOURTH,   transmitter_variables[3],   "",      help_actual_flow_value;
  }
}







/*
############################################################################
##                                                                        ##
##     Special Commands 128+129:   Slot for unsigned char variables       ##
##                                                                        ##
############################################################################
*/


VARIABLE sprache
{
    LABEL "|001Language"
          "|049Sprache";
    HELP  "|001select language for the display of the converter"
          "|049Sprache im Display des Messumformers";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE ENUMERATED
	{
        {  0, "|001German"
              "|049Deutsch"  },
        {  1, "|001English"
              "|049Englisch" }
	}
}

COLLECTION OF VARIABLE col_sprache
{
    MEMBERS
    {
        DIGITAL_VALUE, sprache, [blank], blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE betriebsart
{
  LABEL "|001Operating mode"
        "|049Betriebsart";
  HELP  "|001Flowrate and totalizer units based on the operating mode"
        "|049Durchfluss- und Zhlereinheit werden entsprechend "
            "der Betriebsart eingestellt ";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
	{
    {  0, "|001Liquid Qv"
          "|049Flssigkeit Qv" },
    {  1, "|001Liquid Qm"
          "|049Flssigkeit Qm" },
    {  2, "|001Gas Qv"
          "|049Gas Qv"          },
    {  3, "|001Gas Norm Qn"
          "|049Gas Norm Qn"     },
    {  4, "|001Gas Standard Qs"
          "|049Gas Standard Qs" },
    {  5, "|001Gas Qm"
          "|049Gas Qm"          }
	}
}

COLLECTION OF VARIABLE col_betriebsart
{
  MEMBERS
  {
    DIGITAL_VALUE, betriebsart, [blank], blnk;
  }
}

/*------------------------------------------------------------------

VARIABLE normzustand
{
  LABEL "Normzustand";
  HELP "Hilfe Normzustand";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  VALIDITY IF (betriebsart == 2 || betriebsart == 3  || betriebsart == 3)
                  { TRUE; } ELSE { FALSE; }
  TYPE ENUMERATED
	{
    {  0, "1.0133bara  0C" },
    {  1, "1.0133bara 20C" }
	}
}

COLLECTION OF VARIABLE col_normzustand
{
  MEMBERS
  {
    DIGITAL_VALUE, normzustand, [blank], blnk;
  }
}

------------------------------------------------------------------

VARIABLE gasberechnung
{
    LABEL "Gasberechnung";
    HELP "Hilfe Gasberechnung";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (betriebsart == 2 || betriebsart == 3  || betriebsart == 3)
                    { TRUE; } ELSE { FALSE; }
    TYPE ENUMERATED
	{
        {  0, "Ideales Gas"         },
        {  1, "Ausgleichskoeff"     },
        {  2, "Van der Waals"       }
	}
}

COLLECTION OF VARIABLE col_gasberechnung
{
    MEMBERS
    {
        DIGITAL_VALUE, gasberechnung, [blank], blnk;
    }
}

------------------------------------------------------------------

VARIABLE VdW_gastabelle
{
    LABEL "VdW Gastabelle";
    HELP "Hilfe VdW Gastabelle";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF ((betriebsart == 2 || betriebsart == 3 || betriebsart == 4)
                 && gasberechnung == 2)
                    { TRUE; } ELSE { FALSE; }
    TYPE ENUMERATED
	{
        {  0, "Sauerstoff"                         },
        {  1, "Stickstoff"                         },
        {  2, "Helium"                             },
        {  3, "Wasserstoff"                        },
        {  4, "Argon"                              },
        {  5, "Neon"                               },
        {  6, "Chlor"                              },
        {  7, "Kohlenmonoxid"                      },
        {  8, "Kohlendioxid"                       },
        {  9, "Schwefeldioxid"                     },
        { 10, "Stickoxid"                          },
        { 11, "Ammoniak"                           },
        { 12, "Chlorwasserstoff"                   },
        { 13, "Schwefelwas.st."                    },
        { 14, "Methan"                             },
        { 15, "Acetylen"                           },
        { 16, "Aethylen"                           },
        { 17, "Aethan"                             },
        { 18, "Propylen"                           },
        { 19, "Propan"                             },
        { 20, "Benzol"                             },
        { 21, "Butan-n"                            },
        { 22, "---"                                }
    }
}

COLLECTION OF VARIABLE col_VdW_gastabelle
{
    MEMBERS
    {
        DIGITAL_VALUE, VdW_gastabelle, [blank], blnk;
    }
}

------------------------------------------------------------------*/

VARIABLE anzeige_1_zeile
{
  LABEL "|0011. line"
        "|0491.Zeile";
  HELP  "|001Select the parameter to be shown on the fist line "
            "of the display of the converter."
        "|049Auswahl der Anzeige in der 1. Zeile "
            "des Displays des Messumformers";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
	{
    display_mode
	}
}

COLLECTION OF VARIABLE col_anzeige_1_zeile
{
    MEMBERS
    {
        DIGITAL_VALUE, anzeige_1_zeile, [blank], blnk;
    }
}


/*------------------------------------------------------------------*/

VARIABLE anzeige_2_zeile
{
  LABEL "|0012. line"
        "|0492.Zeile";
  HELP  "|001Select the parameter to be shown on the 2nd line "
            "of the display of the converter."
        "|049Auswahl der Anzeige in der 2. Zeile "
            "des Displays des Messumformers";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
	{
    display_mode
	}
}

COLLECTION OF VARIABLE col_anzeige_2_zeile
{
    MEMBERS
    {
        DIGITAL_VALUE, anzeige_2_zeile, [blank], blnk;
    }
}


/*------------------------------------------------------------------*/

VARIABLE anzeige_2_zeile_mpx
{
  LABEL "|0012.l.mplx"
        "|0492.Z.mplx";
  HELP  "|001Selection of the parameter multiplex displayed on the 2nd line"
        "|049Auswahl des Parameters fr die Multiplex Anzeige der 2. Zeile";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
	{
    display_mode
	}
}

COLLECTION OF VARIABLE col_anzeige_2_zeile_mpx
{
    MEMBERS
    {
        DIGITAL_VALUE, anzeige_2_zeile_mpx, [blank], blnk;
    }
}


/*------------------------------------------------------------------*/

VARIABLE multiplex
{
  LABEL "Multiplex";
  HELP  "|001Multiplex mode for the 2nd line on or off."
        "|049Ein / Ausschalten der Multiplex Anzeige der 2. Zeile";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
	{
    { 0,  "|001off"
          "|049aus" },
    { 1,  "|001on"
          "|049ein"  }
	}
}

COLLECTION OF VARIABLE col_multiplex
{
    MEMBERS
    {
        DIGITAL_VALUE, multiplex, [blank], blnk;
    }
}

/*------------------------------------------------------------------

VARIABLE stromausgang
{
    LABEL "Stromausgang";
    HELP "Hilfe Stromausgang";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE ENUMERATED
	{
        {  0, "0-20mA" },
        {  1, "4-20mA" },
        {  2, "0-10mA" },
        {  3, "2-10mA" },
        {  4, "0-5 mA" }
	}
}

COLLECTION OF VARIABLE col_stromausgang
{
    MEMBERS
    {
        DIGITAL_VALUE, stromausgang, [blank], blnk;
    }
}

------------------------------------------------------------------*/

/*
VARIABLE Iout_alarm
{
  LABEL "|001Current at alarm"
        "|049Iout bei Alarm";
  HELP  "|001Current output settings at alarm status"
        "|049Setzen des Stromausganges bei Alarm";
  CLASS DEVICE;
  HANDLING READ;
  TYPE ENUMERATED
	{
    {  0, "115%" }
	}
}
  */

COLLECTION OF VARIABLE col_Iout_alarm
{
  MEMBERS
  {
  /*
    DIGITAL_VALUE, Iout_alarm, [blank], blnk;
    */
    DIGITAL_VALUE, flow_alarm_select, [blank], blnk;
  }
}

/*------------------------------------------------------------------

VARIABLE temp_messen
{
    LABEL "Temp. messen";
    HELP "Hilfe Temp. messen";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE ENUMERATED
	{
        {  0, "aus" },
        {  1, "ein" }
	}
}

COLLECTION OF VARIABLE col_temp_messen
{
    MEMBERS
    {
        DIGITAL_VALUE, temp_messen, [blank], blnk;
    }
}

------------------------------------------------------------------

VARIABLE druck_messen
{
    LABEL "Temp. messen";
    HELP "Hilfe Druck messen";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE ENUMERATED
	{
        {  0, "aus" },
        {  1, "ein" }
	}
}

COLLECTION OF VARIABLE col_druck_messen
{
    MEMBERS
    {
        DIGITAL_VALUE, druck_messen, [blank], blnk;
    }
}

------------------------------------------------------------------

VARIABLE kommunikation
{
    LABEL "Kommunikation";
    HELP "Hilfe Kommunikation";
    CLASS DEVICE;
    HANDLING READ;
    TYPE ENUMERATED
	{
        {  0, "HART"        },
        {  1, "ASCII"       },
        {  2, "Drucker 7"   },
        {  3, "Drucker 8"   },
        {  4, "Drucker 9"   }
	}
}

COLLECTION OF VARIABLE col_kommunikation
{
    MEMBERS
    {
        DIGITAL_VALUE, kommunikation, [blank], blnk;
    }
}

------------------------------------------------------------------

VARIABLE baudrate
{
    LABEL "Baudrate";
    HELP "Hilfe Baudrate";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE ENUMERATED
	{
        {  0, "  110"       },
        {  1, "  300"       },
        {  2, "  600"       },
        {  3, " 1200"       },
        {  4, " 2400"       },
        {  5, " 4800"       },
        {  6, " 9600"       },
        {  7, "14400"       },
        {  8, "19200"       },
        {  9, "28800"       }

	}
}

COLLECTION OF VARIABLE col_baudrate
{
    MEMBERS
    {
        DIGITAL_VALUE, baudrate, [blank], blnk;
    }
}

------------------------------------------------------------------

VARIABLE druckertyp
{
    LABEL "Druckertyp";
    HELP "Hilfe Druckertyp";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE ENUMERATED
	{
        {  0, "Standard"        },
        {  1, "F&P Docuprint"   },
        {  2, "Standard Cr Lf"  }
	}
}

COLLECTION OF VARIABLE col_druckertyp
{
    MEMBERS
    {
        DIGITAL_VALUE, druckertyp, [blank], blnk;
    }
}

------------------------------------------------------------------*/

VARIABLE signalisierung
{
  LABEL "|001Signalisation"
        "|049Signalisierung";
  HELP  "|001Signalisation"
        "|049 Signalisierung";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  VALIDITY
    IF (kodenummer == KODENUMMER)
      { TRUE; }
    ELSE
      { FALSE; }
  TYPE ENUMERATED
  {
    {  0, "|001I/Pulse/HART"
          "|049I/Puls/HART"  },
    {  1, "|001I/Alarm/HART"
          "|049I/Alarm/HART" },
    {  2, "|001I/HART"
          "|049I/HART"       }
/*          ,
    {  3, "|001I/Pulse_FSK"
          "|049I/Puls_FSK"   },
    {  4, "|001I/Alarm_FSK"
          "|049I/Alarm_FSK"  }
    */
	}
}

/*
COLLECTION OF VARIABLE col_signalisierung
{
    MEMBERS
    {
        DIGITAL_VALUE, signalisierung, [blank], blnk;
    }
}
  */

/*------------------------------------------------------------------*/

VARIABLE einheit_Qv
{
  LABEL "|001Flow Unit Qv"
        "|049Durchflusseinh. Qv";
  HELP  "|001Flow unit depends on operating mode"
        "|049Durchflusseinheit in Abhngigkeit von der Betriebsart";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  VALIDITY
    IF (betriebsart == 0 || betriebsart == 2 || betriebsart == 3 || betriebsart == 4)
              { TRUE; }
    ELSE
              { FALSE; }
  TYPE ENUMERATED
	{
                                      /* volumen */
    units_flow_volume
  }
}

COLLECTION OF VARIABLE col_einheit_Qv
{
  MEMBERS
  {
    DIGITAL_VALUE, einheit_Qv, [blank], blnk;
  }
}

/*------------------------------------------------------------------*/

VARIABLE einheit_Qm
{
  LABEL "|001Flow Unit Qm"
        "|049Durchflusseinh. Qm";
  HELP  "|001Flow unit depends on operating mode"
        "|049Durchflusseinheit in Abhngigkeit von der Betriebsart";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  VALIDITY IF (betriebsart == 1 || betriebsart == 5)
              { TRUE; }
           ELSE
              { FALSE; }
  TYPE ENUMERATED
	{
                                      /* masse */
    units_flow_mass
    }
}

COLLECTION OF VARIABLE col_einheit_Qm
{
    MEMBERS
    {
        DIGITAL_VALUE, einheit_Qm, [blank], blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE einheit_Zv
{
  LABEL "|001Totl. Unit Zv"
        "|049Einh. Zhler Zv";
  HELP  "|001Totalizer unit depends on operating mode"
        "|049Zhlereinheit in Abhngigkeit von der Betriebsart";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  VALIDITY
    IF (betriebsart == 0 || betriebsart == 2 || betriebsart == 3 || betriebsart == 4)
            { TRUE; }
    ELSE
            { FALSE; }
  TYPE ENUMERATED
	{
                                      /* volumen */
    units_total_volume
  }
}

COLLECTION OF VARIABLE col_einheit_Zv
{
    MEMBERS
    {
        DIGITAL_VALUE, einheit_Zv, [blank], blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE einheit_Zm
{
  LABEL "|001Totl. Unit Zm"
        "|049Einh. Zhler Zm";
  HELP  "|001Totalizer unit depends on operating mode"
        "|049Zhlereinheit in Abhngigkeit von der Betriebsart";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  VALIDITY IF (betriebsart == 1 || betriebsart == 5)
              { TRUE; }
           ELSE
              { FALSE; }
  TYPE ENUMERATED
	{
                                      /* masse */
    units_total_mass
  }
}

COLLECTION OF VARIABLE col_einheit_Zm
{
    MEMBERS
    {
        DIGITAL_VALUE, einheit_Zm, [blank], blnk;
    }
}

/*------------------------------------------------------------------*/

/*==================================================================*/

/*
VARIABLE einheit_Z
{
  LABEL "|001Totl. Unit"
        "|049Einheit Zhler";
  HELP  "|001Totalizer unit depends on operating mode"
        "|049Zhlereinheit in Abhngigkeit von der Betriebsart";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
  {
  IF (betriebsart==1 || betriebsart==5)
    {
    */
/*                                 fuer betriebsarten mit masse 1,5 */
/*    units_total_mass                   */
/*
       }
     ELSE
     */
/*     {                           fuer betriebsarten mit volumen 0,2,3,4 */
/*    units_total_volume                  */
/*
    }
  }
}
  */
/*
COLLECTION OF VARIABLE col_einheit_Z
{
  MEMBERS
  {
    DIGITAL_VALUE, einheit_Z, [blank], blnk;
  }
}
  */



UNIT totalizer_unit_relation
{
    totalizer_units
/*
    einheit_Z
  */
    :totalizer_value
    ,impuls_faktor
}


/*
VARIABLE einheit_Q
{
  LABEL "|001Flow Unit"
        "|049Durchflusseinheit";
  HELP  "|001Flow unit depends on operating mode"
        "|049Durchflusseinheit in Abhngigkeit von der Betriebsart";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
  */
  /*
  {                              fuer betriebsarten mit masse 1,5 */
  /*
  IF (betriebsart==1 || betriebsart==5)
    {                            masse  */
/*    units_flow_mass                   */
/*
       }
     ELSE
     */
/*     {                           fuer betriebsarten mit volumen 0,2,3,4 */
/*    units_flow_volume                  */
/*
    }
  }
}

COLLECTION OF VARIABLE col_einheit_Q
{
    MEMBERS
    {
        DIGITAL_VALUE, einheit_Q, [blank], blnk;
    }
}

 ==================================================================*/
/*
VARIABLE einheit_dichte
{
  LABEL "|001Unit density"
        "|049Einheit Dichte";
  HELP "Available units for density.";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  TYPE ENUMERATED
	{
    {  0, "g/ml"        },
    {  1, "g/cm3"       },
    {  2, "g/l"         },
    {  3, "kg/l"        },
    {  4, "kg/m3"       },
    {  5, "lb/ft3"      },
    {  6, "lb/ugl"      }
  }
}
  */

COLLECTION OF VARIABLE col_einheit_dichte
{
  MEMBERS
  {
/*    DIGITAL_VALUE, einheit_dichte, [blank], blnk; */
    DIGITAL_VALUE, dichte_einheit, [blank], blnk;
  }
}

/*------------------------------------------------------------------

VARIABLE einheit_temp
{
    LABEL "Einheit Temp.";
    HELP "Hilfe Einheit Temp.";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE ENUMERATED
	{
        {  0, "C"        },
        {  1, "F"        }
    }
}

COLLECTION OF VARIABLE col_einheit_temp
{
    MEMBERS
    {
        DIGITAL_VALUE, einheit_temp, [blank], blnk;
    }
}

------------------------------------------------------------------

VARIABLE einheit_druck
{
    LABEL "Einheit Druck";
    HELP "Hilfe Einheit DRuck";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE ENUMERATED
	{
        {  0, "bar"        },
        {  1, "PSIA"       }
    }
}

COLLECTION OF VARIABLE col_einheit_druck
{
    MEMBERS
    {
        DIGITAL_VALUE, einheit_druck, [blank], blnk;
    }
}

------------------------------------------------------------------*/

/*------------------------------------------------------------------*/

ARRAY OF COLLECTION unsigned_char_variables
{
    LABEL "col uc_var";
    HELP  "help unsigned char variables";
    ELEMENTS
    {
     /* Index   Item                         Description         Help */
        20,      col_betriebsart            , [blank],            [blank];
/*
        21,      col_normzustand            , [blank],            [blank];
        22,      col_gasberechnung          , [blank],            [blank];
        23,      col_VdW_gastabelle         , [blank],            [blank];
  */
        50,      col_sprache                , [blank],            [blank];
        51,      col_anzeige_1_zeile        , [blank],            [blank];
        52,      col_anzeige_2_zeile        , [blank],            [blank];
        53,      col_anzeige_2_zeile_mpx    , [blank],            [blank];
        54,      col_multiplex              , [blank],            [blank];
        60,      col_einheit_Qv             , [blank],            [blank];
        61,      col_einheit_Qm             , [blank],            [blank];
        62,      col_einheit_Zv             , [blank],            [blank];
        63,      col_einheit_Zm             , [blank],            [blank];
/*
        64,      col_einheit_temp           , [blank],            [blank];
        65,      col_einheit_druck          , [blank],            [blank];
  */
        66,      col_einheit_dichte         , [blank],            [blank];
/*
       100,      col_stromausgang           , [blank],            [blank];
  */
       101,      col_Iout_alarm             , [blank],            [blank];
/*
       120,      col_kommunikation          , [blank],            [blank];
       121,      col_baudrate               , [blank],            [blank];
       122,      col_druckertyp             , [blank],            [blank];

       130,      col_temp_messen            , [blank],            [blank];
       131,      col_druck_messen           , [blank],            [blank];
  */
    }
}


VARIABLE unsigned_char_variable_code
{
	HELP [index_into_dynamic_variables_array_help];
/*
	APPHELP "This variable can represent measured or calculated type variables."
		" The numeric assigned to a Field Device variable can never be"
		" changed. If it is changed this would be a violation of the Forward"
		" Compatibility rules."
		" HART_VAR:XMTR VAR CODE";
*/
    TYPE INDEX unsigned_char_variables;
	CLASS USER_INTERFACE;

}


COMMAND read_unsigned_char_variables
{
  NUMBER 128;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{
      unsigned_char_variable_code (INFO,INDEX)
		}

		REPLY
		{
			response_code, device_status,
      unsigned_char_variable_code,
      unsigned_char_variables[unsigned_char_variable_code].DIGITAL_VALUE
		}
	}

	RESPONSE_CODES
	{
    0,  SUCCESS,        [no_command_specific_errors];
		2,	MISC_ERROR,			[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		8,	MISC_WARNING,		[update_failure];
   32,  MODE_ERROR,     device_busy;
	}
}


COMMAND write_unsigned_char_variables
{
  NUMBER 129;

  OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
      unsigned_char_variable_code (INFO,INDEX)
      unsigned_char_variables[unsigned_char_variable_code].DIGITAL_VALUE
		}

		REPLY
		{
			response_code, device_status,
      unsigned_char_variable_code,
      unsigned_char_variables[unsigned_char_variable_code].DIGITAL_VALUE
		}
	}

	RESPONSE_CODES
	{
    0,  SUCCESS,          [no_command_specific_errors];
    2,  DATA_ENTRY_ERROR, [invalid_selection];
		3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
		4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
    5,  MISC_ERROR,       [too_few_data_bytes_recieved];
    6,  MISC_ERROR,       [xmtr_specific_command_error];
    8,  MISC_WARNING,     [update_failure];
   32,  MODE_ERROR,       device_busy;
	}
}





/*
############################################################################
##                                                                        ##
##       Special Commands 130+131:   Slot for unsigned int variables      ##
##                                                                        ##
############################################################################
*/


VARIABLE ueberlauf
{
  LABEL "|001Overflow"
        "|049berlauf";
  HELP  "|001Number of totalizer overflows. "
            "Every 10,000,000 units totalizer one overflow is added, "
            "so the total totalizer is computed by the product of "
            "overflowcounter * 10,000,000 plus actual totalizer"
        "|049Anzahl der Zhlerberlufe. "
            "Alle 10.000.000 Zhlereinheiten wird ein berlauf gezhlt, "
            "somit ergibt sich ein Gesamtzhlerstand aus dem "
            "Produkt berlauf * 10.000.000 plus aktueller Zhlerstand";
  /* CLASS DEVICE; */
  CLASS DYNAMIC & INPUT;
  HANDLING READ;
  TYPE UNSIGNED_INTEGER (2)
  {
    DISPLAY_FORMAT "5d";
    EDIT_FORMAT "5d";
  }
}

COLLECTION OF VARIABLE col_ueberlauf
{
  MEMBERS
  {
    DIGITAL_VALUE, ueberlauf     , [blank], blnk;
    DIGITAL_UNITS, keine_einheit , [units], blnk;
  }
}

/*------------------------------------------------------------------

VARIABLE geraeteadresse
{
    LABEL "Gerteadresse";
    HELP "Hilfe Gerteadresse";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE UNSIGNED_INTEGER (2)
    {
        DISPLAY_FORMAT "2d";
        EDIT_FORMAT "2d";
    }
}

COLLECTION OF VARIABLE col_geraeteadresse
{
    MEMBERS
    {
        DIGITAL_VALUE, geraeteadresse   , [blank], blnk;
        DIGITAL_UNITS, keine_einheit    , [units], blnk;
    }
}

------------------------------------------------------------------

VARIABLE netzausfall
{
    LABEL "Netzausfall";
    HELP "Hilfe Netzausfall";
    CLASS DEVICE;
    HANDLING READ;
    TYPE UNSIGNED_INTEGER (2)
    {
        DISPLAY_FORMAT "5d";
        EDIT_FORMAT "5d";
    }
}

COLLECTION OF VARIABLE col_netzausfall
{
    MEMBERS
    {
        DIGITAL_VALUE, netzausfall      , [blank], blnk;
        DIGITAL_UNITS, keine_einheit    , [units], blnk;
    }
}

------------------------------------------------------------------*/

VARIABLE kodenummer
{
    LABEL "|001Code number"
          "|049Servicecode";
    HELP  "|001Enter the service code number for changing "
              "of protected parameters."
          "|049Zum -ndern geschtzter Parameter muss "
              "der richtige Servicecode eingegeben werden.";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE UNSIGNED_INTEGER (2)
    {
        DISPLAY_FORMAT "5d";
        EDIT_FORMAT "5d";
    }
}

COLLECTION OF VARIABLE col_kodenummer
{
    MEMBERS
    {
        DIGITAL_VALUE, kodenummer       , [blank], blnk;
        DIGITAL_UNITS, keine_einheit    , [units], blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE geraetenummer
{
  LABEL "|001Instrument no."
        "|049Gertenummer";
  HELP  "|001Caution! Changing the Instrument number will "
            "result in loose of communication."
        "|049Vorsicht! -ndern der Gertenummer fhrt "
            "zum Verlust der Kommunikation";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
  TYPE UNSIGNED_INTEGER (2)
  {
    DISPLAY_FORMAT "5d";
    EDIT_FORMAT "5d";
  }
}

COLLECTION OF VARIABLE col_geraetenummer
{
  MEMBERS
  {
    DIGITAL_VALUE, geraetenummer    , [blank]  , blnk;
    DIGITAL_UNITS, keine_einheit    , [units]  , blnk;
  }
}

/*------------------------------------------------------------------*/

VARIABLE winkel_0_grad
{
/*    LABEL "Winkel 0 Grad"; */
    LABEL "|001Adjust 0%"
          "|049Abgleich 0%";
    HELP  "|001Adjust at 0%"
          "|049Abgleich der elektronischen Positionserfassung des "
              "Magnetfolgesystems bei 0% Schwebekrperhub";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE UNSIGNED_INTEGER (2)
    {
        DISPLAY_FORMAT "5d";
        EDIT_FORMAT "5d";
    }
}

COLLECTION OF VARIABLE col_winkel_0_grad
{
    MEMBERS
    {
        DIGITAL_VALUE, winkel_0_grad    , [blank]  , blnk;
        DIGITAL_UNITS, keine_einheit    , [units]  , blnk;
    }
}
/*------------------------------------------------------------------*/

VARIABLE winkel_90_grad
{
/*    LABEL "Winkel 90 Grad"; */
    LABEL "|001Adjust 100%"
          "|049Abgleich 100%";
    HELP  "|001Adjust at 100%"
          "|049Abgleich der elektronischen Positionserfassung des "
              "Magnetfolgesystems bei 100% Schwebekrperhub";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE UNSIGNED_INTEGER (2)
    {
        DISPLAY_FORMAT "5d";
        EDIT_FORMAT "5d";
    }
}

COLLECTION OF VARIABLE col_winkel_90_grad
{
    MEMBERS
    {
        DIGITAL_VALUE, winkel_90_grad   , [blank]  , blnk;
        DIGITAL_UNITS, keine_einheit    , [units]  , blnk;
    }
}

/*------------------------------------------------------------------*/
/*------------------------------------------------------------------*/


ARRAY OF COLLECTION unsigned_int_variables
{
    LABEL "col ui_var";
    HELP  "help ui variables";
    ELEMENTS
    {
     /* Index   Item                      Description         Help */
         0,     col_geraetenummer       , [blank],            [blank];
        80,     col_ueberlauf           , [blank],            [blank];
/*
       120,     col_geraeteadresse      , [blank],            [blank];
       140,     col_netzausfall         , [blank],            [blank];
  */
       141,     col_kodenummer          , [blank],            [blank];

       160,     col_winkel_0_grad       , [blank],            [blank];
       161,     col_winkel_90_grad      , [blank],            [blank];
    }
}


VARIABLE unsigned_int_variable_code
{
	HELP [index_into_dynamic_variables_array_help];
/*
	APPHELP "This variable can represent measured or calculated type variables."
		" The numeric assigned to a Field Device variable can never be"
		" changed. If it is changed this would be a violation of the Forward"
		" Compatibility rules."
		" HART_VAR:XMTR VAR CODE";
*/
    TYPE INDEX unsigned_int_variables;
	CLASS USER_INTERFACE;
}


COMMAND read_unsigned_int_variables
{
    NUMBER 130;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{
            unsigned_int_variable_code (INFO,INDEX)
		}

		REPLY
		{
			response_code, device_status,
      unsigned_int_variable_code,
      unsigned_int_variables[unsigned_int_variable_code].DIGITAL_UNITS,
      unsigned_int_variables[unsigned_int_variable_code].DIGITAL_VALUE
		}
	}

	RESPONSE_CODES
	{
    0,  SUCCESS,        [no_command_specific_errors];
		2,	MISC_ERROR,			[invalid_selection];
		5,	MISC_ERROR,			[too_few_data_bytes_recieved];
		6,	MISC_ERROR,			[xmtr_specific_command_error];
		8,	MISC_WARNING,		[update_failure];
   32,  MODE_ERROR,      device_busy;
	}
}


COMMAND write_unsigned_int_variables
{
  NUMBER 131;

  OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
      unsigned_int_variable_code (INFO,INDEX)
      unsigned_int_variables[unsigned_int_variable_code].DIGITAL_UNITS,
      unsigned_int_variables[unsigned_int_variable_code].DIGITAL_VALUE
		}

		REPLY
		{
			response_code, device_status,
      unsigned_int_variable_code,
      unsigned_int_variables[unsigned_int_variable_code].DIGITAL_UNITS,
      unsigned_int_variables[unsigned_int_variable_code].DIGITAL_VALUE
		}
	}

	RESPONSE_CODES
	{
    0,  SUCCESS,          [no_command_specific_errors];
    2,  MISC_ERROR,       [invalid_selection];
		3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
		4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
    5,  MISC_ERROR,       [too_few_data_bytes_recieved];
    6,  MISC_ERROR,       [xmtr_specific_command_error];
    8,  MISC_WARNING,     [update_failure];
   32,  MODE_ERROR,       device_busy;
	}
}



/*
############################################################################
##                                                                        ##
##       Special Commands 132+133:   Slot for float variables             ##
##                                                                        ##
############################################################################
*/


/*------------- fuer betriebsarten mit fluessigkeit 0,1 --------------*/

VARIABLE viskositaet
{
  LABEL "|001Viskosity"
        "|049Viskositt";
  HELP  "|001Fluid viscosity at operating conditions"
        "|049Viskositt des Messstoffes unter Betriebsbedingungen";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  CONSTANT_UNIT "mPas";
  VALIDITY IF (betriebsart == 0 || betriebsart == 1)
              { TRUE; }
           ELSE
              { FALSE; }
  TYPE FLOAT
  {
    DISPLAY_FORMAT "8.1f";
    EDIT_FORMAT "8.1f";
  }
}

COLLECTION OF VARIABLE col_viskositaet
{
    MEMBERS
    {
        DIGITAL_VALUE, viskositaet       , [blank], [blank];
        DIGITAL_UNITS, spezielle_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------

VARIABLE betriebs_temp
{
    LABEL "Betriebstemp.";
    HELP "Hilfe Betriebstemp.";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (betriebsart == 2 || betriebsart == 3 || betriebsart == 4)
                { TRUE; }
             ELSE
                { FALSE; }
    TYPE FLOAT
    {
		DISPLAY_FORMAT "6.1f";
		EDIT_FORMAT "6.1f";
    }
}

COLLECTION OF VARIABLE col_betriebs_temp
{
    MEMBERS
    {
        DIGITAL_VALUE, betriebs_temp       , [blank], [blank];
        DIGITAL_UNITS, temperatur_einheit  , blnk, blnk;
    }
}

------------------------------------------------------------------

VARIABLE betriebs_druck
{
    LABEL "Betriebsdruck";
    HELP "Hilfe Betriebsdruck";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (betriebsart == 2 || betriebsart == 3 || betriebsart == 4)
                    { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
		DISPLAY_FORMAT "7.3f";
		EDIT_FORMAT "7.3f";
    }
}

COLLECTION OF VARIABLE col_betriebs_druck
{
    MEMBERS
    {
        DIGITAL_VALUE, betriebs_druck , [blank], [blank];
        DIGITAL_UNITS, druck_einheit  , blnk, blnk;
    }
}

------------------------------------------------------------------

VARIABLE ausgleichskoeff
{
    LABEL "Ausgleichskoeff.";
    HELP "Hilfe Ausgleichskoeffizient";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF ((betriebsart == 2 || betriebsart == 3 || betriebsart == 4)
                 && gasberechnung == 1)
                    { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "5.3f";
        EDIT_FORMAT "5.3f";
    }
}

COLLECTION OF VARIABLE col_ausgleichskoeff
{
    MEMBERS
    {
        DIGITAL_VALUE, ausgleichskoeff  , [blank], [blank];
        DIGITAL_UNITS, spezielle_einheit, blnk, blnk;
    }
}

------------------------------------------------------------------

VARIABLE VdW_a
{
    LABEL "Van der Waals a";
    HELP "Hilfe Van der Vaals a";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF ((betriebsart == 2 || betriebsart == 3 || betriebsart == 4)
                 && gasberechnung == 2)
                    { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.5f";
        EDIT_FORMAT "8.5f";
    }
}

COLLECTION OF VARIABLE col_VdW_a
{
    MEMBERS
    {
        DIGITAL_VALUE, VdW_a             , [blank], [blank];
        DIGITAL_UNITS, spezielle_einheit , blnk, blnk;
    }
}

------------------------------------------------------------------

VARIABLE VdW_b
{
    LABEL "Van der Waals b";
    HELP "Hilfe Van der Vaals b";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF ((betriebsart == 2 || betriebsart == 3 || betriebsart == 4)
                 && gasberechnung == 2)
                    { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "7.5f";
        EDIT_FORMAT "7.5f";
    }
}

COLLECTION OF VARIABLE col_VdW_b
{
    MEMBERS
    {
        DIGITAL_VALUE, VdW_b             , [blank], [blank];
        DIGITAL_UNITS, spezielle_einheit , blnk, blnk;
    }
}

--------------- fuer betriebsarten mit gas (norm, standard) 3,4 ----*/

VARIABLE normdichte
{
  LABEL "|001Normal Density"
        "|049Normdichte";
  HELP  "|001the gas reference density for the operating mode "
            "selection Gas Normal Qn and Gas standard Qs"
        "|049Die Bezugsdichte des Gases fr die Betriebsart Gas Norm Qn "
            "und Gas Standard Qs";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  VALIDITY IF (betriebsart == 3 || betriebsart == 4)
              { TRUE; }
           ELSE
              { FALSE; }
  TYPE FLOAT
  {
    DISPLAY_FORMAT "8.5f";
    EDIT_FORMAT "8.5f";
  }
}

COLLECTION OF VARIABLE col_normdichte
{
    MEMBERS
    {
        DIGITAL_VALUE, normdichte     , [blank], [blank];
        DIGITAL_UNITS, dichte_einheit , blnk, blnk;
    }
}

/*--------------------- fuer alle betriebsarten ------------------*/

VARIABLE betriebsdichte
{
    LABEL "|049Betriebsdichte"
          "|001Operating density";
    HELP  "|001density at operating conditions. "
              "If the gas density is unknown a calculated value must be entered"
          "|049Dichte unter Betriebsbedingungen. "
              "Wenn Dichte bei Gasen nicht bekannt ist, "
              "muss eine Berechnung durchgefhrt werden";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.3f";
        EDIT_FORMAT "8.3f";
    }
}

COLLECTION OF VARIABLE col_betriebsdichte
{
    MEMBERS
    {
        DIGITAL_VALUE, betriebsdichte   , [blank], [blank];
        DIGITAL_UNITS, dichte_einheit   , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE Qmax_medium
{
    LABEL "|001Qmax Fluid"
          "|049Qmax Medium";
    HELP  "|001Calculated max. fluid flowrate based on the water calibration"
          "|049Berechneter max. Messstoffdurchfluss "
              "auf Basis der Wasserkalibrierung";
    CLASS DEVICE;
    HANDLING READ;
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.2f";
        EDIT_FORMAT "8.2f";
    }
}

COLLECTION OF VARIABLE col_Qmax_medium
{
    MEMBERS
    {
        DIGITAL_VALUE, Qmax_medium      , [blank], [blank];
        DIGITAL_UNITS, flow_unit,      [units],              [blank];
        /*
        DIGITAL_UNITS, einheit_Q,           [units],              [blank];
        */
    }
}

/*------------------------------------------------------------------*/

VARIABLE Qmax
{
    LABEL "Qmax ";
    HELP  "|001Entry from 90% to 100% of Qmax Fluid"
          "|049Eingabe von 90% bis 100% von Qmax Medium";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.2f";
        EDIT_FORMAT "8.2f";
    }
}

COLLECTION OF VARIABLE col_Qmax
{
    MEMBERS
    {
        DIGITAL_VALUE, Qmax            , [blank], [blank];
        DIGITAL_UNITS, flow_unit,      [units],              [blank];
        /*
        DIGITAL_UNITS, einheit_Q,           [units],              [blank];
        */
    }
}

/*------------------------------------------------------------------*/

VARIABLE schleichmenge
{
    LABEL "|001Low Flow Cutoff"
          "|049Schleichmenge";
    HELP  "|001for flowrates below the entered value the messurement is stopped"
          "|049Unterhalb der eingegebenen Schleichmenge erfolgt keine Messung";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.2f";
        EDIT_FORMAT "8.2f";
    }
}

COLLECTION OF VARIABLE col_schleichmenge
{
    MEMBERS
    {
        DIGITAL_VALUE, schleichmenge   , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE impuls_faktor
{
  LABEL "|001Pulse factor"
        "|049Impuls Faktor";
  HELP  "|001For signal output pulse_FSK/I or pulse "
            "the pulse output value includes the entered value"
        "|049Bei Signalisierung Puls_FSK/I oder Puls erhlt der Impulsausgang "
            "entsprechend multiplizierte Werte";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE FLOAT
    {
		DISPLAY_FORMAT "7.3f";
		EDIT_FORMAT "7.3f";
    }
}

COLLECTION OF VARIABLE col_impuls_faktor
{
  MEMBERS
  {
    DIGITAL_VALUE, impuls_faktor    , [blank], [blank];
    DIGITAL_UNITS, totalizer_units  , blnk, blnk;
/*
        DIGITAL_UNITS, einheit_Z        , [units], blnk;
        */
  }
}

/*------------------------------------------------------------------*/

VARIABLE impulsbreite
{
  LABEL "|001Pulse width"
        "|049Impulsbreite";
  HELP  "|001Duration of the pulse required by the connected intrument"
        "|049Dauer des Impulses zur Abstimmung auf das Ausgabegert";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    CONSTANT_UNIT "ms";
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.3f";
        EDIT_FORMAT "8.3f";
    }
}

COLLECTION OF VARIABLE col_impulsbreite
{
    MEMBERS
    {
        DIGITAL_VALUE, impulsbreite      , [blank], [blank];
        DIGITAL_UNITS, spezielle_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

/*
VARIABLE daempfung
{
  LABEL "|001Damping"
        "|049Dmpfung";
  HELP  "|001Damping of the current output, reponse time for "
            "rapid flowrate changes"
        "|049Dmpfung des Stromausganges, Ansprechzeit "
            "fr sprungartige Durchflussnderungen";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  TYPE FLOAT
  {
		DISPLAY_FORMAT "5.1f";
		EDIT_FORMAT "5.1f";
  }
}
  */

COLLECTION OF VARIABLE col_daempfung
{
  MEMBERS
  {
  /*
    DIGITAL_VALUE, daempfung          , [blank], [blank];
    */
    DIGITAL_VALUE, flow_damping_value , [blank], [blank];
    DIGITAL_UNITS, zeit_einheit       , blnk, blnk;
  }
}

/*------------------------------------------------------------------*/

VARIABLE max_alarm
{
  LABEL "Max-Alarm";
  HELP  "|001Process alarm activated when flowrate exceeds entered value. "
            "Contact V8,V9 is closed"
        "|049Bei berschreiten des Wertes erfolgt Prozessalarm. "
            "Kontakt V8,V9 wird geschlossen";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  TYPE FLOAT
  {
		DISPLAY_FORMAT "5.1f";
		EDIT_FORMAT "5.1f";
  }
}

COLLECTION OF VARIABLE col_max_alarm
{
    MEMBERS
    {
        DIGITAL_VALUE, max_alarm        , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit  , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE min_alarm
{
  LABEL "Min-Alarm";
  HELP  "|001Process alarm activated when flowrate is below entered value. "
            "Contact V8,V9 is closed"
        "|049Bei Unterschreiten des Wertes erfolgt Prozessalarm. "
            "Kontakt V8,V9 wird geschlossen";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE FLOAT
    {
		DISPLAY_FORMAT "5.1f";
		EDIT_FORMAT "5.1f";
    }
}

COLLECTION OF VARIABLE col_min_alarm
{
    MEMBERS
    {
    DIGITAL_VALUE, min_alarm    , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit  , blnk, blnk;
    }
}

/*------------------------------------------------------------------

VARIABLE druck_0
{
	LABEL "Druck 0%";
	HELP "Hilfe Druck 0%";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE FLOAT
    {
		DISPLAY_FORMAT "6.2f";
		EDIT_FORMAT "6.2f";
    }
}

COLLECTION OF VARIABLE col_druck_0
{
    MEMBERS
    {
        DIGITAL_VALUE, druck_0        , [blank], [blank];
        DIGITAL_UNITS, druck_einheit  , blnk, blnk;
    }
}

------------------------------------------------------------------

VARIABLE druck_100
{
	LABEL "Druck 100%";
	HELP "Hilfe Druck 100%";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    TYPE FLOAT
    {
		DISPLAY_FORMAT "6.2f";
		EDIT_FORMAT "6.2f";
    }
}

COLLECTION OF VARIABLE col_druck_100
{
    MEMBERS
    {
        DIGITAL_VALUE, druck_100     , [blank], [blank];
        DIGITAL_UNITS, druck_einheit , blnk, blnk;
    }
}

------------------------------------------------------------------*/

VARIABLE Qmax_wasser
{
    LABEL "|001Range water"
          "|049Qmax Wasser";
    HELP  "|001Range water"
          "|049 Qmax Wasser";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    CONSTANT_UNIT "l/h";   /* UNITS_CODE (82 );      */
    VALIDITY IF (kodenummer == KODENUMMER)
                { TRUE; }
             ELSE
                { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.2f";
        EDIT_FORMAT "8.2f";
    }
}

COLLECTION OF VARIABLE col_Qmax_wasser
{
    MEMBERS
    {
        DIGITAL_VALUE, Qmax_wasser      , [blank], [blank];
        DIGITAL_UNITS, flow_unit,      [units],              [blank];
        /*
        DIGITAL_UNITS, einheit_Q,           [units],              [blank];
        */
    }
}

/*------------------------------------------------------------------*/

VARIABLE sk_dichte
{
    LABEL "|001Float density"
          "|049SK-Dichte";
    HELP  "|001Float density"
          "|049SK-Dichte";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.3f";
        EDIT_FORMAT "8.3f";
    }
}

COLLECTION OF VARIABLE col_sk_dichte
{
    MEMBERS
    {
        DIGITAL_VALUE, sk_dichte     , [blank], [blank];
        DIGITAL_UNITS, dichte_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE viskositaetszahl
{
  LABEL "|001Viscosty number"
        "|049Viskosittszahl";
  HELP  "|001Viscosty number"
        "|049Viskosittszahl";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  CONSTANT_UNIT "mPas";
  VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
  TYPE FLOAT
  {
    DISPLAY_FORMAT "8.1f";
    EDIT_FORMAT "8.1f";
  }
}

COLLECTION OF VARIABLE col_viskositaetszahl
{
  MEMBERS
  {
    DIGITAL_VALUE, viskositaetszahl  , [blank], [blank];
    DIGITAL_UNITS, spezielle_einheit , blnk, blnk;
  }
}

/*------------------------------------------------------------------*/

VARIABLE abgl_Iout_4mA
{
  LABEL "|001Adjust Iout 4 mA"
        "|049Abgl. Iout 4 mA";
  HELP  "|001Adjust Iout 4 mA"
        "|049Abgleich Iout bei 4 mA";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
  TYPE FLOAT
  {
		DISPLAY_FORMAT "6.3f";
		EDIT_FORMAT "6.3f";
  }
}

COLLECTION OF VARIABLE col_abgl_Iout_4mA
{
  MEMBERS
  {
    DIGITAL_VALUE, abgl_Iout_4mA  , [blank], [blank];
    DIGITAL_UNITS, strom_einheit    , blnk, blnk;
  }
}

/*------------------------------------------------------------------*/

VARIABLE abgl_Iout_20mA
{
  LABEL "|001Adjust Iout 20 mA"
        "|049Abgl. Iout 20 mA";
  HELP  "|001Adjust Iout 20 mA"
        "|049Abgleich Iout bei 20 mA";
  CLASS DEVICE;
  HANDLING READ & WRITE;
  VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
  TYPE FLOAT
  {
		DISPLAY_FORMAT "6.3f";
		EDIT_FORMAT "6.3f";
  }
}

COLLECTION OF VARIABLE col_abgl_Iout_20mA
{
    MEMBERS
    {
    DIGITAL_VALUE, abgl_Iout_20mA , [blank], [blank];
        DIGITAL_UNITS, strom_einheit    , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE M1
{
    LABEL "M1";
    HELP  "|001Master point no. 1"
          "|049Meisterpunkt Nr.1";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_M1
{
    MEMBERS
    {
        DIGITAL_VALUE, M1              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE M2
{
    LABEL "M2";
    HELP  "|001Master point no. 2"
          "|049Meisterpunkt Nr.2";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_M2
{
    MEMBERS
    {
        DIGITAL_VALUE, M2              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE M3
{
    LABEL "M3";
    HELP  "|001Master point no. 3"
          "|049Meisterpunkt Nr.3";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_M3
{
    MEMBERS
    {
        DIGITAL_VALUE, M3              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE M4
{
    LABEL "M4";
    HELP  "|001Master point no. 4"
          "|049Meisterpunkt Nr.4";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_M4
{
    MEMBERS
    {
        DIGITAL_VALUE, M4              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE M5
{
    LABEL "M5";
    HELP  "|001Master point no. 5"
          "|049Meisterpunkt Nr.5";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_M5
{
    MEMBERS
    {
        DIGITAL_VALUE, M5              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE M6
{
    LABEL "M6";
    HELP  "|001Master point no. 6"
          "|049Meisterpunkt Nr.6";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_M6
{
    MEMBERS
    {
        DIGITAL_VALUE, M6              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE M7
{
    LABEL "M7";
    HELP  "|001Master point no. 7"
          "|049Meisterpunkt Nr.7";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_M7
{
    MEMBERS
    {
        DIGITAL_VALUE, M7              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE M8
{
    LABEL "M8";
    HELP  "|001Master point no. 8"
          "|049Meisterpunkt Nr.8";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_M8
{
    MEMBERS
    {
        DIGITAL_VALUE, M8              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE M9
{
    LABEL "M9";
    HELP  "|001Master point no. 9"
          "|049Meisterpunkt Nr.9";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_M9
{
    MEMBERS
    {
        DIGITAL_VALUE, M9              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE M10
{
    LABEL "M10";
    HELP  "|001Master point no. 10"
          "|049Meisterpunkt Nr.10";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_M10
{
    MEMBERS
    {
        DIGITAL_VALUE, M10             , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE P1
{
    LABEL "P1";
    HELP  "|001Primary point no. 1"
          "|049Testpunkt Nr.1";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_P1
{
    MEMBERS
    {
        DIGITAL_VALUE, P1              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE P2
{
    LABEL "P2";
    HELP  "|001Primary point no. 2"
          "|049Testpunkt Nr.2";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_P2
{
    MEMBERS
    {
        DIGITAL_VALUE, P2              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE P3
{
    LABEL "P3";
    HELP  "|001Primary point no. 3"
          "|049Testpunkt Nr.3";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_P3
{
    MEMBERS
    {
        DIGITAL_VALUE, P3              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE P4
{
    LABEL "P4";
    HELP  "|001Primary point no. 4"
          "|049Testpunkt Nr.4";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_P4
{
    MEMBERS
    {
        DIGITAL_VALUE, P4              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE P5
{
    LABEL "P5";
    HELP  "|001Primary point no. 5"
          "|049Testpunkt Nr.5";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_P5
{
    MEMBERS
    {
        DIGITAL_VALUE, P5              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE P6
{
    LABEL "P6";
    HELP  "|001Primary point no. 6"
          "|049Testpunkt Nr.6";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_P6
{
    MEMBERS
    {
        DIGITAL_VALUE, P6              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE P7
{
    LABEL "P7";
    HELP  "|001Primary point no. 7"
          "|049Testpunkt Nr.7";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_P7
{
    MEMBERS
    {
        DIGITAL_VALUE, P7              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE P8
{
    LABEL "P8";
    HELP  "|001Primary point no. 8"
          "|049Testpunkt Nr.8";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_P8
{
    MEMBERS
    {
        DIGITAL_VALUE, P8              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE P9
{
    LABEL "P9";
    HELP  "|001Primary point no. 9"
          "|049Testpunkt Nr.9";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_P9
{
    MEMBERS
    {
        DIGITAL_VALUE, P9              , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/

VARIABLE P10
{
    LABEL "P10";
    HELP  "|001Primary point no. 10"
          "|049Testpunkt Nr.10";
    CLASS DEVICE;
    HANDLING READ & WRITE;
    VALIDITY IF (kodenummer == KODENUMMER) { TRUE; } ELSE { FALSE; }
    TYPE FLOAT
    {
        DISPLAY_FORMAT "8.1f";
        EDIT_FORMAT "8.1f";
    }
}

COLLECTION OF VARIABLE col_P10
{
    MEMBERS
    {
        DIGITAL_VALUE, P10             , [blank], [blank];
        DIGITAL_UNITS, prozent_einheit , blnk, blnk;
    }
}

/*------------------------------------------------------------------*/





/*------------------------------------------------------------------*/
/*------------------------------------------------------------------*/

ARRAY OF COLLECTION float_variables
{
    LABEL "col fl_var";
    HELP  "help fl variables";
    ELEMENTS
    {
     /* Index   Item                       Description     Help */
         0,      col_Qmax_medium          , [blank]       , [blank];
         1,      col_Qmax                 , [blank]       , [blank];
         2,      col_schleichmenge        , [blank]       , [blank];
        20,      col_viskositaet          , [blank]       , [blank];
/*
        21,      col_betriebs_temp        , [blank]       , [blank];
        22,      col_betriebs_druck       , [blank]       , [blank];
        23,      col_ausgleichskoeff      , [blank]       , [blank];
        24,      col_VdW_a                , [blank]       , [blank];
        25,      col_VdW_b                , [blank]       , [blank];
  */
        26,      col_normdichte           , [blank]       , [blank];
        27,      col_betriebsdichte       , [blank]       , [blank];
        90,      col_impuls_faktor        , [blank]       , [blank];
        91,      col_impulsbreite         , [blank]       , [blank];
       100,      col_daempfung            , [blank]       , [blank];
       110,      col_max_alarm            , [blank]       , [blank];
       111,      col_min_alarm            , [blank]       , [blank];
/*
       130,      col_druck_0              , [blank]       , [blank];
       131,      col_druck_100            , [blank]       , [blank];
  */
       160,      col_abgl_Iout_4mA        , [blank]       , [blank];
       161,      col_abgl_Iout_20mA       , [blank]       , [blank];
       164,      col_Qmax_wasser          , [blank]       , [blank];
       165,      col_sk_dichte            , [blank]       , [blank];
       166,      col_viskositaetszahl     , [blank]       , [blank];
       170,      col_M1                   , [blank]       , [blank];
       171,      col_M2                   , [blank]       , [blank];
       172,      col_M3                   , [blank]       , [blank];
       173,      col_M4                   , [blank]       , [blank];
       174,      col_M5                   , [blank]       , [blank];
       175,      col_M6                   , [blank]       , [blank];
       176,      col_M7                   , [blank]       , [blank];
       177,      col_M8                   , [blank]       , [blank];
       178,      col_M9                   , [blank]       , [blank];
       179,      col_M10                  , [blank]       , [blank];
       180,      col_P1                   , [blank]       , [blank];
       181,      col_P2                   , [blank]       , [blank];
       182,      col_P3                   , [blank]       , [blank];
       183,      col_P4                   , [blank]       , [blank];
       184,      col_P5                   , [blank]       , [blank];
       185,      col_P6                   , [blank]       , [blank];
       186,      col_P7                   , [blank]       , [blank];
       187,      col_P8                   , [blank]       , [blank];
       188,      col_P9                   , [blank]       , [blank];
       189,      col_P10                  , [blank]       , [blank];
    }
}





VARIABLE float_variable_code
{
	HELP [index_into_dynamic_variables_array_help];
/*
	APPHELP "This variable can represent measured or calculated type variables."
		" The numeric assigned to a Field Device variable can never be"
		" changed. If it is changed this would be a violation of the Forward"
		" Compatibility rules."
		" HART_VAR:XMTR VAR CODE";
*/
  TYPE INDEX float_variables;
	CLASS USER_INTERFACE;
}


COMMAND read_float_variables
{
  NUMBER 132;

	OPERATION READ;

	TRANSACTION
	{
		REQUEST
		{
      float_variable_code (INFO,INDEX)
		}

		REPLY
		{
			response_code, device_status,
      float_variable_code,
      float_variables[float_variable_code].DIGITAL_UNITS,
      float_variables[float_variable_code].DIGITAL_VALUE
		}
	}

	RESPONSE_CODES
	{
		0,	SUCCESS,			[no_command_specific_errors];
    5,  MISC_ERROR,   [too_few_data_bytes_recieved];
    6,  MISC_ERROR,   [xmtr_specific_command_error];
   32,  MODE_ERROR,   device_busy;
	}
}


COMMAND write_float_variables
{
  NUMBER 133;

  OPERATION WRITE;

	TRANSACTION
	{
		REQUEST
		{
      float_variable_code (INFO,INDEX)
      float_variables[float_variable_code].DIGITAL_UNITS,
      float_variables[float_variable_code].DIGITAL_VALUE
		}

		REPLY
		{
			response_code, device_status,
      float_variable_code,
      float_variables[float_variable_code].DIGITAL_UNITS,
      float_variables[float_variable_code].DIGITAL_VALUE
		}
	}

	RESPONSE_CODES
	{
    0,  SUCCESS,          [no_command_specific_errors];
    2,  MISC_ERROR,       [invalid_selection];
		3,	DATA_ENTRY_ERROR,	[passed_parameter_too_large];
		4,	DATA_ENTRY_ERROR,	[passed_parameter_too_small];
    5,  MISC_ERROR,       [too_few_data_bytes_recieved];
    6,  MISC_ERROR,       [xmtr_specific_command_error];
   32,  MODE_ERROR,       device_busy;
	}
}


/*-------------------------------------------------------------------------*/


COMMAND cmd_reset_totalizer          /* Zaehler+UEberlauf loeschen */
{
  NUMBER 140;
  OPERATION COMMAND;
	TRANSACTION
	{
    REQUEST
    {
    }
    REPLY
		{
      response_code, device_status
		}
	}

  RESPONSE_CODES
  {
    0,  SUCCESS,     [no_command_specific_errors];
    5,  MISC_ERROR,  [too_few_data_bytes_recieved];
	}
}

METHOD reset_totalizer
{
  LABEL  "|001Reset Totalizer"
         "|049Zhler lschen";

  DEFINITION
  {
    ACKNOWLEDGE("|001Really reset totalizer ?"
                "|049Zhler wirklich lschen ?");
    send_command(140);
  }
}

/*
METHOD change_signalisation
{
    LABEL "|001Change signalisation"
          "|049Signalisierung ndern";

    DEFINITION
    {
      char status[STATUS_SIZE];

      ACKNOWLEDGE("|001Really change signalisation ?"
                  "|049Signalisierung wirklich ndern ?");
      send(166,status);
      if ( status[STATUS_RESPONSE_CODE] )
        {
          display_response_status(166,status[STATUS_RESPONSE_CODE]);
        }
    }
}
  */

COMMAND cmd_read_signalisation
{
  NUMBER 165;
  OPERATION READ;
	TRANSACTION
	{
		REQUEST
    {
    }
		REPLY
		{
      response_code, device_status,
      signalisierung
		}
	}

  RESPONSE_CODES
    {
       0, SUCCESS,     [no_command_specific_errors];
       5, MISC_ERROR,  [too_few_data_bytes_recieved];
      32, MISC_ERROR,  "device busy";
    }
}


COMMAND cmd_write_signalisation
{
  NUMBER 166;
  OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
    {
      signalisierung
    }
		REPLY
		{
      response_code, device_status,
      signalisierung
		}
	}

  RESPONSE_CODES
    {
       0, SUCCESS,     [no_command_specific_errors];
       5, MISC_ERROR,  [too_few_data_bytes_recieved];
      32, MISC_ERROR,  "device busy";
    }
}

METHOD reset_config_changed_flag
{
    LABEL "|001Reset Conf.Changed"
          "|049-nder.flag rcks.";

    DEFINITION
    {
        ACKNOWLEDGE("|001Really Reset Configuration Changed Flag ?"
                    "|049-nderungsflag wirklich rcksetzen?");
        send_command(38);
    }
}


/*
############################################################################
##                                                                        ##
##                                 Refresh                                ##
##                                                                        ##
############################################################################
*/


REFRESH refresh_betrieb
{
  betriebsart

  :einheit_Qv
  ,einheit_Qm
  ,einheit_Zv
  ,einheit_Zm
  ,flow_upper_sensor_limit
  ,flow_lower_sensor_limit
  ,flow_minimum_span
  ,flow_upper_range_value
  ,flow_lower_range_value
  ,Qmax
  ,Qmax_wasser
}

REFRESH refresh_einh_dichte
{
  dichte_einheit

  :betriebsdichte
  ,normdichte
  ,sk_dichte
}

REFRESH refresh_dichte
{
   betriebsdichte
  ,normdichte
  ,sk_dichte
  ,Qmax_wasser

  :flow_upper_sensor_limit
  ,flow_lower_sensor_limit
  ,flow_minimum_span
  ,flow_upper_range_value
  ,flow_lower_range_value
  ,Qmax
  ,Qmax_medium
  ,impuls_faktor
  ,impulsbreite
}

REFRESH refresh_einh_durchfl
{
  einheit_Qm
  ,einheit_Qv

  :flow_unit
  ,flow_upper_sensor_limit
  ,flow_lower_sensor_limit
  ,flow_minimum_span
  ,flow_upper_range_value
  ,flow_lower_range_value
  ,Qmax
  ,Qmax_medium
  ,Qmax_wasser
  ,impuls_faktor
  ,impulsbreite
}

REFRESH refresh_einh_zaehler
{
  einheit_Zv
  ,einheit_Zm

  :totalizer_units
  ,impuls_faktor
  ,impulsbreite
}

REFRESH refresh_impuls
{
  impuls_faktor
  ,impulsbreite

  :impulsbreite
  ,impuls_faktor
}

